define([], function(){
	
	"use strict";
	
	/**
	 * A class that represents the Workflow editor context. 
	 * @class
	 * @exports WFEditorContext
	 */
	var WFEditorContext = function(){
		
		// private object that will contain all WFEditor 
		var objects = {};
		
		// gets a particular instance from the context
		this.get = function(name) {
			return objects[name];
		};
		
		// sets a particular instance to the contxt
		this.set = function (name, obj) {
			objects[name] = obj;
		}
		
	};
	
	return WFEditorContext;
	
});