define({
	WorkflowItemType: {
		Node: "Node",
		Pin: "Pin",
		Token: "Token",
		Edge: "Edge",
		Helper: "Helper"
	},

	HitAreaClass: {
		NodeSelect: "NodeSelect"
	},
	
	HitAreaOptions: {
		CURSOR: "cursor",
		TOOLTIP: "tooltip"
	},
	Privileges: {
		addEdges: "addEdges",
		moveEdges: "moveEdges",
		removeEdges: "removeEdges",
		canSave: "canSave",
		addNodes: "addNodes",
		moveNodes: "moveNodes",
		removeNodes: "removeNodes",
		viewNodeConfiguration: "viewNodeConfiguration",
		editNodeConfiguration: "editNodeConfiguration",
		zoomToActiveNode: "zoomToActiveNode",
		copyNodes: "copyNodes"
		
	},

	DefaultPrivileges: {
		addEdges: true,
		moveEdges: true,
		removeEdges: true,
		canSave: true,
		addNodes: true,
		moveNodes: true,
		removeNodes: true,
		viewNodeConfiguration: true,
		editNodeConfiguration: true,
		zoomToActiveNode: false,
		copyNodes: true
		
	}
});