/*!
 * jQuery floatingScroll Plugin v2.3.0
 * supported by jQuery v1.4.3+
 *
 * https://github.com/Amphiluke/floating-scroll
 * http://amphiluke.github.io/floating-scroll/
 *
 * Copyright (c) 2011-2017 Amphiluke
 */

define("component/table/DropdownOverflowUtil",["jquery"],function(b){var f={repositionDropdowns:function(a,c){a.on("show.bs.dropdown",function(a){var d=b(a.target).find(".dropdown-menu");b.data(a.target,"dropdownMenuReference",d);b.data(d[0],"dropdownButtonReference",a.target);b("body").append(d.detach());d.addClass("RepositionedDropdown");var e=b(a.target).offset();d.hasClass("dropdown-menu-right")?d.css({display:"block",top:e.top+b(a.target).outerHeight(),right:b(window).width()-e.left-b(a.target).outerWidth()}):
d.css({display:"block",top:e.top+b(a.target).outerHeight(),left:e.left});c&&d.addClass(c);a.stopPropagation()}).on("hide.bs.dropdown",function(a){var d=b.data(a.target,"dropdownMenuReference");0<d.length&&(b(a.target).append(d.detach().css({display:"",top:"",left:"",right:""})),d.removeClass("RepositionedDropdown"),c&&b(a.target).removeClass(c));a.stopPropagation()})},cleanupDropdowns:function(){b(".RepositionedDropdown").each(function(){var a=b.data(this,"dropdownButtonReference");void 0==a?b(this).remove():
b.contains(document,a)||(b(this).removeClass("RepositionedDropdown"),b(a).after(this))})},wcrinit:function(a){var c=b(a).attr("data-overflownamespace");f.repositionDropdowns(b(a),c)}};return f});
(function(b,f){"function"===typeof define&&define.amd?define("lib/jquery.floatingscroll",["jquery"],f):"object"===typeof module&&module.exports?f(require("jquery")):f(b.jQuery)})(this,function(b){function f(a){var b=a.closest(".fl-scrolls-body");this.cont=a[0];b.length&&(this.scrollBody=b);this.sbar=this.initScroll();this.visible=!0;this.updateAPI();this.syncSbar(this.cont);this.addEventHandlers()}b.extend(f.prototype,{initScroll:function(){var a=b("<div class='fl-scrolls'></div>");b("<div></div>").appendTo(a).css({width:this.cont.scrollWidth+
"px"});return a.appendTo(this.cont)},addEventHandlers:function(){var a=this,c,g,d;c=a.eventHandlers=[{$el:a.scrollBody||b(window),handlers:{scroll:function(){a.checkVisibility()}}},{$el:b(window),handlers:{resize:function(){a.updateAPI()}}},{$el:a.sbar,handlers:{scroll:function(){a.visible&&a.syncCont(this,!0)}}},{$el:b(a.cont),handlers:{scroll:function(){a.syncSbar(this,!0)},focusin:function(){setTimeout(function(){a.syncSbar(a.cont)},0)},"update.fscroll adjustScroll":function(b){("fscroll"===b.namespace||
"adjustScroll"===b.type)&&a.updateAPI()},"destroy.fscroll":function(b){"fscroll"===b.namespace&&a.destroyAPI()}}}];g=0;for(d=c.length;g<d;g++)c[g].$el.bind(c[g].handlers)},checkVisibility:function(){var a=this.sbar[0].scrollWidth<=this.sbar[0].offsetWidth,b;a||(a=this.cont.getBoundingClientRect(),b=this.scrollBody?this.scrollBody[0].getBoundingClientRect().bottom:window.innerHeight||document.documentElement.clientHeight,a=a.bottom<=b||a.top>b);this.visible===a&&(this.visible=!a,this.sbar.toggleClass("fl-scrolls-hidden"))},
syncCont:function(b,c){!0===this.preventSyncCont?this.preventSyncCont=!1:(this.preventSyncSbar=!!c,this.cont.scrollLeft=b.scrollLeft)},syncSbar:function(b,c){!0===this.preventSyncSbar?this.preventSyncSbar=!1:(this.preventSyncCont=!!c,this.sbar[0].scrollLeft=b.scrollLeft)},updateAPI:function(){var a=this.cont,c=a.getBoundingClientRect();this.sbar.width(b(a).outerWidth());this.scrollBody||this.sbar.css("left",c.left+"px");b("div",this.sbar).width(a.scrollWidth);this.checkVisibility()},destroyAPI:function(){var b=
this.eventHandlers,c,g;c=0;for(g=b.length;c<g;c++)b[c].$el.unbind(b[c].handlers);this.sbar.remove()}});b.fn.attachScroll=b.fn.floatingScroll=function(a){!arguments.length||"init"===a?this.each(function(){new f(b(this))}):f.prototype.hasOwnProperty(a+"API")&&this.trigger(a+".fscroll");return this}});
define("component/table/Table",["jquery","require","./DropdownOverflowUtil","lib/jquery.floatingscroll"],function(b,f,a){var c=function(a,d,c,h){this._context=b(a);this._tablesection=this._context.find(".wcr-table-section");0<this._tablesection.length&&!this._tablesection.hasClass("noscrollbarfloating")&&this._context.hasClass("wcr161_apply_floatingscroll")&&(this._tablesection.floatingScroll(),this._tablesection.on("contentchange",_.bind(function(){this._tablesection.floatingScroll("update")},this)));
this._itemrowSelector=d;this._checkboxSelector=c;this._clickToSelectActive=h;this._initializeRowSelection();this._initializeDropdownInteraction();0<this._context.find(".wcr-table-actions-row").not(".no-actions").not(".no-sticky-actions").length&&0<this._context.find(".wcr-table-actions-row .action").length&&f(["stickykit"],function(){var d=b(a).find(".wcr-table-actions-row");d.stick_in_parent({parent:b(a)});var c=d.parent()[0],e=function(){"fixed"===d.css("position")?d.css("left",c.getBoundingClientRect().left+
10):d.css("left","initial")};b(window).on("scroll",e);d.on("sticky_kit:stick",e)});this._context.get(0).Table=this};c.prototype._initializeRowSelection=function(){var a=this;if(this._checkboxSelector&&this._itemrowSelector){if(this._clickToSelectActive)this._tablesection.on("click",this._itemrowSelector,function(d){if(!b(d.target).is("a, .btn, .action, .dropdown, input, .radio")&&!b(d.target).parentsUntil(this).is("a, .btn, .action, .dropdown, input, .radio")){var c=b(a._checkboxSelector,this);0<
c.length&&(!c.is("[data-toggle-all]")&&!c.is(":disabled"))&&(b(d.target).is(c)||a._doSelection(d,c))}});this._tablesection.on("change",this._checkboxSelector,function(){if(!b(this).is("[data-toggle-all]")){b(a._itemrowSelector,a._tablesection).has(this).toggleClass("active",b(this).prop("checked"));var d=a._tablesection.find("input[type='checkbox'][data-toggle-all]"),c=a._tablesection.find(".wcr-table-section").find("input[type='checkbox'][data-toggle-all]");d.not(c).prop("checked",a.isEverythingSelected())}});
this._tablesection.on("click","input[type='checkbox'][data-toggle-all]",function(c){var e=b(this).prop("checked");a.selectAll(e);c.stopPropagation()})}};c.prototype._doSelection=function(b,a){a.prop("checked",!a.prop("checked")).trigger("change");a.is("[type=radio]")&&a.prop("checked")&&this._fixAllActiveClasses()};c.prototype.isEverythingSelected=function(){var a=b(this._checkboxSelector+":visible:not([data-toggle-all]):checked",this._tablesection).length,c=b(this._checkboxSelector+":visible:not([data-toggle-all])",
this._tablesection).length;return a===c};c.prototype._fixAllActiveClasses=function(){var a=this;b(this._itemrowSelector,this._tablesection).each(function(c,e){b(e).toggleClass("active",b(e).find(a._checkboxSelector).is(":checked"))})};c.prototype.selectAll=function(a){this._tablesection.find(this._checkboxSelector,this._tablesection).filter(":visible").prop("checked",a).trigger("change")};c.prototype.toggleSelectAll=function(){this.selectAll(!this.isEverythingSelected())};c.prototype.getContext=function(){return this._context};
c.prototype._initializeDropdownInteraction=function(){a.repositionDropdowns(b(".wcr-table-section",this._context))};c.wcrinit=function(a){typeof a!==b&&(a=b(a));var d=a.attr("data-itemrow-selector"),e=a.attr("data-checkbox-selector");d||(d=" > table.ordtable > tbody > tr",b("> .wcr-table-section > table.ordtable",a).hasClass("gridview")&&(d=" > table.ordtable > tbody > tr > td"));e||(e="input[type='checkbox'][name^='select']");var f="0"===a.attr("data-click-to-select")?!1:!0;new c(a,d,e,f)};return c});