define({
	Tools: {
		MOUSEINTERACTION: "mouseInteractionTool",
		ZOOMTOOL: "zoomTool",
		PANTOOL: "panTool",
		SELECTIONTOOL: "selectionTool",
		MOVENODESTOOL: "moveNodesTool",
		DRAWEDGETOOL: "drawEdgeTool",
		CONTEXTMENUTOOL: "contextMenuTool",
		TOOLTIPTOOL: "toolTipTool"
	},

	State: {
		DEFAULTSTATE: "defaultToolState",

		DRAWINGEDGE: "drawingEdgeState",
		HOVERINGEDGE: "hoveringEdgeState",

		SHOULDMOVE: "shouldMoveNodesState",
		MOVINGNODES: "movingNodesState",

		//states for the panning tool
		PANNINGSTATE: "panningToolState",
		PANNINGSCROLLBARSTATE: "panningScrollbarState",

		//states for the mouse interaction tool
		SELECTIONSTATE: "selectionToolState",
		SHOULDSELECTSTATE: "shouldSelectState",
		
		//States for gallerynodeselector tool
		DRAGGINGNEWNODESTATE: "draggingNewNodeState"

	},
	ZoomLevel: {
		'-5': "0.3",
		'-4': "0.4",
		'-3': "0.5",
		'-2': "0.7",
		'-1': "0.8",
		'0': "0.9",
		'1': "1",
		'2': "1.5"
	},
	zoomLimit: {
		MIN: -5,
		MAX: 2
	},
	Cursors: {
		DEFAULT: "default-cursor",
		POINTER: "pointer-cursor",
		HAND: "hand-cursor"
	},
	ButtonGroups: {
		ZOOM: "zoomActions",
		NAVIGATION: "navigationActions",
		UNDOREDO: "undoRedoActions",
		REMOVENODES: "removeNodesActions",
		STEPTHROUGH: "stepThroughActions"
	},
	ContextMenuGroups: {
		NODE: "nodeActions"	
	},
	Buttons: {
		SELECTION: "activateSelectionTool",
		PAN: "activatePanningTool",
		ZOOMIN: "zoomToIn",
		ZOOMOUT: "zoomToOut",
		ZOOMTOFIT: "ZoomToFit",
		ZOOMTONEXTACTIVE: "ZoomToNextActive",
		ZOOMTOACTIVENODE: "ZoomToActive",
		ZOOMTOPREVIOUSACTIVE: "ZoomToPreviousActive",
		UNDO: "undoButton",
		REDO: "redoButton",
		REMOVENODES: "removeNodesButton",
		COPYNODES: "copyNodesButton",
		PASTENODES: "pasteNodesButton",
		CUTNODES: "cutNodesButton"
	},
	BorderOffsetForPanning: 25 // Selection tool: How close to the border before panning
});
