define([
		"WFEditor/nodeGallery/view/NodeGalleryList",
		"utils/webi18n!WFEditorWCR",
	],
	function (
		NodeGalleryList,
		i18n
	) {
		"use strict";

		/**
		 * WebCenterNodeGalleryList is an implementation of the NodeGalleryList for WebCenter.
		 *
		 * @exports WebCenterNodeGalleryList
		 * @class
		 * @augments NodeGalleryList
		 *             
		 * @param {NodeGallery} nodegallery - the nodegallery to which the NodeGalleryList belongs.
		 */
		var WebCenterNodeGalleryList = function (nodegallery) {
			NodeGalleryList.call(this, nodegallery, i18n);
		};

		WebCenterNodeGalleryList.prototype = Object.create(NodeGalleryList.prototype);
		WebCenterNodeGalleryList.prototype.constructor = WebCenterNodeGalleryList;

		return WebCenterNodeGalleryList;

	});