define(["WFEditorWCR/workflow/panel/WorkflowSmartNameDictionaryService"],
	function (WorkflowSmartNameDicationaryService) {
		"use strict";


		/**
		 * SmartName Dictionary service for attribute values (old)
		 * @param {WebCenterAPI} webCenterAPI    - The WebCenter API to fetch information
		 * @param {String} currentTaskTypeID - Id of the currently opened workflow (to fetch task specifications)
		 * @param {Array.<CustomSmartName>} [customSmartNames] - Custom smartnames if any that need to be added
		 */
		var AttributeValueDictionaryService = function (webCenterAPI, currentTaskTypeID, customSmartNames) {
			WorkflowSmartNameDicationaryService.call(this, webCenterAPI, currentTaskTypeID, customSmartNames);
		};

		AttributeValueDictionaryService.prototype = Object.create(WorkflowSmartNameDicationaryService.prototype);
		AttributeValueDictionaryService.prototype.constructor = AttributeValueDictionaryService;

		/**
		 * @override
		 */
		AttributeValueDictionaryService.prototype.addDates = function () {
			return true;
		};

		return AttributeValueDictionaryService;

	});