
define('tpl!web-viewer/layout/component/DocumentSelector', function(){return function(d){
var __t,__p='',__j=Array.prototype.join,print=function(){__p+=__j.call(arguments,'');};
__p+='<div class="documentItem"> \r\n	<img class="thumbnail pull-left" src="'+
((__t=(d.thumbnailUrl))==null?'':__t)+
'" />\r\n	<ul class="info">		\r\n		<li class="documentName">\r\n			'+
((__t=(d.docInfo.documentName))==null?'':_.escape(__t))+
'\r\n		</li>\r\n		\r\n		';
 if(d.docInfo.project!==undefined){ 
__p+='\r\n			<li class="projectName">\r\n				<span class="docSelectorKey">'+
((__t=(d.i18n("WCProject")))==null?'':_.escape(__t))+
'</span> '+
((__t=(d.docInfo.project))==null?'':_.escape(__t))+
'\r\n			</li>\r\n		';
 } 
__p+='	\r\n		\r\n		';
 if(!d.docInfo.isGroup){ 
__p+='				\r\n			';
 if(d.docInfo.pageNumber!== undefined && !d.docInfo.referencedFrom){ 
__p+='\r\n				<li class="docSelectorPageInfo">	\r\n					<span class="pageNumber">'+
((__t=(d.i18n("PageUC")))==null?'':_.escape(__t))+
'&nbsp;'+
((__t=(d.docInfo.pageNumber))==null?'':_.escape(__t))+
'</span>\r\n						';
 if(d.docInfo.pageCount!==null){ 
__p+='\r\n							'+
((__t=(d.i18n("OfKeyWord")))==null?'':_.escape(__t))+
' '+
((__t=(d.docInfo.pageCount))==null?'':_.escape(__t))+
'\r\n						';
 } 
__p+='\r\n				</li>\r\n			';
 } 
__p+='\r\n		\r\n			';
 if(d.docInfo.versionNumber!==undefined){
__p+='\r\n				<li class="versionNumber">\r\n					<span class="docSelectorKey">'+
((__t=(d.i18n("WCVersion")))==null?'':_.escape(__t))+
'</span> '+
((__t=(d.docInfo.versionNumber))==null?'':_.escape(__t))+
'\r\n				</li>\r\n			';
 } 
__p+='\r\n		';
 } else { 
__p+='\r\n			';
 if(d.docInfo.versionNumber!==undefined){
__p+='\r\n				<li class="versionNumber">\r\n					<span class="docSelectorKey">'+
((__t=(d.i18n("WCVersion")))==null?'':_.escape(__t))+
' </span>'+
((__t=(d.docInfo.versionId))==null?'':_.escape(__t))+
' \r\n				</li>\r\n			';
 } 
__p+='\r\n			<li class="showAllPages"  ';
if(d.docInfo.isOpen){
__p+='style="display: none;"';
}
__p+='>'+
((__t=(d.i18n("ShowAllPages")))==null?'':_.escape(__t))+
' </li>\r\n			<li class="hideAllPages"  ';
if(!d.docInfo.isOpen){
__p+='style="display: none;"';
}
__p+='>'+
((__t=(d.i18n("HideAllPages")))==null?'':_.escape(__t))+
' </li>\r\n		';
 } 
__p+='\r\n		\r\n			 ';
 if (d.docInfo.referencedFrom) { 
__p+=' \r\n				<li class="cadReferencedFrom">\r\n                	<i class="icon icon-WCR_Link"></i> '+
((__t=(d.docInfo.referencedFrom))==null?'':_.escape(__t))+
'\r\n				</li>\r\n            ';
 } 
__p+='\r\n	</ul>\r\n</div>';
return __p;
}});
define('web-viewer/layout/component/DocumentDropdownMenu',["component/dropdownmenu/DropdownMenu",
		"Template",
		"tpl!web-viewer/layout/component/DocumentSelector",
		"jquery",
		"underscore"
	],
	function (
		DropdownMenu,
		Template,
		tpl,
		$,
		_) {
		"use strict";

		/** 
		 *
		 * @class A DocumentDropdownMenu is a dropdownmenu that when clicked shows a dropdown with a list of document pages. New
		 * documents can be added to the list and the documents can be enabled/disabled. Changing the selected pages makes the previous
		 * selected page back available in the the dropdown. It is also possible to group document pages. Group elements will hide all its elements,
		 * when the group element is clicked all the pages of this group will become visible. Only document pages of the same type should be added
		 * the same group.
		 *
		 * @exports Layout.Component.DocumentDropdownMenu
		 * @constructor
		 * @augments Layout.Component.DropdownMenu
		 * @param {Core.ViewerFacade} f
		 * @param {Function}          onDocumentSelect      - function to execute when a document is selected
		 * @param {String}            [emptyListText]       - text shown in the list when no documents can be selected
		 * @param {String}            [nothingSelectedText] - Text shown in the dropdown when no document is selected
		 * @param {String}            [deselectText]        - Text used for the action to deselect the currently selected document, when not passed it is not possible to deselect the currently selected document
		 * @param {Function}          [deselectCallback]    - callback to execute when the document gets deselected, first parameter is the deselected pageId
		 * @param {Boolean}           [isMobile]            - adapt layout for mobile
		 * @param {Boolean}           [isCompact]           - if true version number is put behind the document (on the same line)
		 */
		var DocumentDropdownMenu = function (f, onDocumentSelect, emptyListText, nothingSelectedText, deselectText, deselectCallback, isMobile, isCompact) {
			this.f = f;
			DropdownMenu.call(this, this.f.i18n, this.f.getContext(), this.f.isMobile(), "bottom", "documentSelector", 300);

			/**
			 * @member {Function} function that's executed when a new document gets selected
			 * @private
			 */
			this._onDocChange = onDocumentSelect;

			/**
			 * @member {JQueryObj} visible part of the dropdownmenu with the currently selected document page
			 */
			this.element = $("<div/>").addClass("selectedDocument");
			this.attachTo(this.element);

			this._isMobile = isMobile;

			/**
			 * @member {JQueryObj} element for the currently selected element
			 */
			this._selectedDocumentElement = $("<div>");
			if (this._isMobile) {
				this.element.append('<i class="icon-WCR_Down"></i>');
			}
			this.element.append(this._selectedDocumentElement);
			if (!this._isMobile) {
				this.element.append($("<div>").addClass("docSelectorCaret").append($("<span/>").addClass("caret")));
			}

			/**
			 * @member {Object} the selected document
			 * @private
			 */
			this._selectedDocumentPage = null;

			/**
			 * @member {Number} the number of enabled documents
			 * @private
			 */
			this._enabledDocuments = 0;

			/**
			 * @member {Object} maps a group name to an array of element names
			 * @private
			 */
			this._elementGrouping = {};

			/**
			 * @member {String} the currently active group, group of which all elements are visible
			 * @private
			 */
			this._activeGroup = null;

			/**
			 * @member {DataConstants.documentPageType} - if the dropdown is restricted to show only document pages of this doc type
			 * @private
			 */
			this._enabledDocType = null;

			/**
			 * @member {String} id of the divider element in the dropdown
			 */
			this.dividerId = null;

			/**
			 * @member {Template} template used to generate each row of document page information
			 */
			this.t = new Template(this.f.i18n, tpl);

			this.unveil = _.debounce(_.partial(this._unveil, true), 100);
			this.t.d.compact = isCompact;
			this._deselectText = deselectText || "";
			this._nothingSelectedText = nothingSelectedText || "";
			this._deselectCallback = deselectCallback;

			if (this._deselectText !== "" && this._nothingSelectedText !== "") {
				var html = $("<div />").addClass("deselectElement").html(this._nothingSelectedText);
				this.deselectElement = {
					name: "deselectAction",
					content: html,
					icon: undefined,
					action: _.bind(function () {
						var selectedPageId = this.getSelectedDocumentPageId();
						this.deselectCurrentPage(true);
						this._deselectCallback(selectedPageId);
					}, this),
					enabled: true
				};
				this.addAction(this.deselectElement);
				this.disableDocumentPage(this.deselectElement.name);
				this._selectedDocumentPage = this.deselectElement;
				this._selectedDocumentElement.html(this._selectedDocumentPage.content.clone());
				this._enabledDocuments++;
			}
			if (emptyListText !== "") {
				var html = $("<div />").addClass("deselectElement").html(emptyListText);
				this.emptyListElement = {
					name: "emptyList",
					content: html,
					icon: undefined,
					action: function () {},
					enabled: true
				};
				this.addAction(this.emptyListElement);
			}
		};

		DocumentDropdownMenu.prototype = Object.create(DropdownMenu.prototype);
		DocumentDropdownMenu.prototype.constructor = DocumentDropdownMenu;

		/**
		 * Initialize the document dropdown menu
		 * @private
		 * @override
		 */
		DocumentDropdownMenu.prototype._initialize = function () {
			DropdownMenu.prototype._initialize.call(this);
			if (this._isMobile) {
				this.popover.setPlacementOptions(["bottomLeft"]);
			} else {
				this.popover.setPlacementOptions(["bottom", "top"]);
			}
		};

		/**
		 * Add a document to the dropdown menu
		 * @param {Object} documentInfo : description of the document
		 * @param {String} groupName - name of the group the document belongs to
		 * @example
		 * {
		 * 	pageId: 'uniquePageId',
		 * 	project: 'projectName',
		 * 	documentName: 'nameOfTheDocument',
		 * 	[versionNumber: number,]
		 * 	[pageNumber: page,]
		 * 	[pageCount: numberOfPages,]
		 *  thumbnailUrl: String,
		 *  docType: docTypeConstant,
		 *  [isVisible: Boolean,]
		 *  [group: String]
		 * }
		 */
		DocumentDropdownMenu.prototype.addDocumentPage = function (docInfo, groupName) {
			if (groupName !== undefined && this._elementGrouping[groupName] !== undefined) {
				if (this._elementGrouping[groupName].length === 0) { //no previous elements where added to the group, use the first page's information for the group element
					this.t.d.docInfo = _.clone(docInfo); //make sure to make copy, will be changing this object for generating html
					this.t.d.docInfo.isGroup = true; //identify this element as group
					this.t.d.docInfo.isOpen = this.items[groupName].isOpen;
					this.t.d.thumbnailUrl = docInfo.thumbnailUrl;
					var html = this.t.getRenderedHtml();
					this.setActionText(groupName, $(html)); //copy generated html in group element
					if (this._enabledDocType !== null && docInfo.docType !== this._enabledDocType) {
						this.disableDocumentPage(groupName);
					}
				}
				this._elementGrouping[groupName].push(docInfo.pageId);
			}
			if (this.items[docInfo.pageId] === undefined) { //to make sure a document page doesn't get added twice
				this.t.d.docInfo = docInfo;
				this.t.d.thumbnailUrl = "";
				var html = this.t.getRenderedHtml();
				var dropdownElement = {
					name: docInfo.pageId,
					content: html,
					icon: undefined,
					action: _.bind(function (pageId) {
						this._itemClicked(pageId);
					}, this, docInfo.pageId),
					enabled: true,
					docType: docInfo.docType,
					isVisible: (groupName === undefined //if page doesn't belong to a group, make it visible
						|| (this._activeGroup === groupName //if the groupName is the same as the currently active group 
							&& (this._enabledDocType === null || docInfo.docType === this._enabledDocType))), //and the enabled doctype is null or the doctypes are the same make the element visible
					group: groupName, //name of the group this element belongs to
					thumb: docInfo.thumbnailUrl,
					isUnveiled: false,
					after: (docInfo.prepend && this.deselectElement) ? this.deselectElement.name : undefined
				};
				this.addAction(dropdownElement);
				if (dropdownElement.isVisible) { //only if the element is visible at creation of the element add to the counter of currently active pages
					this._enabledDocuments++;
				}
				if (this.emptyListElement !== undefined && this._enabledDocuments > 0) {
					this.hideElement(this.emptyListElement.name);
					this.showElement(this.dividerId);
				}
			}
		};

		/**
		 * Remove a document page from the document dropdown menu.
		 * @param {String} pageId - the unique ID for the document page
		 */
		DocumentDropdownMenu.prototype.removeDocumentPage = function (pageId) {
			this.removeAction(pageId);
			delete this.items[pageId];
		};

		/**
		 * Add a divider to the dropdown menu, there can only be one divider added to the dropdown menu
		 */
		DocumentDropdownMenu.prototype.addDivider = function () {
			if (this.dividerId === null) {
				this.dividerId = DropdownMenu.prototype.addDivider.call(this); //same the id to be able to hide when the emptylist element is shown
				if (this.emptyListElement !== undefined && this.emptyListElement.isVisible) { //if the emptylist element is already visible, make sure to hide the divider
					this.hideElement(this.dividerId);
				}
			}
		};

		/**
		 * Add a document group to the dropdown menu. After adding the group document pages can be added to that group.
		 * The group element will be shown in the dropdown when the enabled document type is the same as the elements in the group and
		 * the elements of the group are not enabled in the dropdown. Only document pages of the same document type should be added to
		 * a document group.
		 * @param {String} groupName - name of the group, is the name for the element in the dropdown
		 * @param {Function} [beforeClickCallback] - callback will be called before the group element in the dropdown is clicked.
		 * @param {Function} [afterClickCallback] - callback will be called after the group element in the dropdown is clicked.
		 */
		DocumentDropdownMenu.prototype.addDocumentGroup = function (groupName, beforeClickCallback, afterClickCallback) {
			this._elementGrouping[groupName] = [];
			var html = $("<div />"); //first create an empty element for the group, when adding document pages to the group, the first added page will be used for the dropdown element
			this.groupElement = {
				name: groupName,
				content: html,
				icon: undefined,
				isOpen: false,
				action: _.bind(function () {
					if (beforeClickCallback !== undefined) {
						beforeClickCallback(); //call the callback at the beginning of the click
					}

					if (this.isGroupOpen(groupName)) {
						this.hideElementGroup(groupName);
					} else {
						this.showElementGroup(groupName); //show the clicked group
					}

					// dropdown size has changed, so trigger repositioning and unveiling
					this.show();

					if (afterClickCallback !== undefined) {
						afterClickCallback(); //call the callback at the end of the click
					}
				}, this),
				enabled: true,
				doNotHideOnClick: true, //to make sure the dropdown will not be hidden when the group element is clicked in the dropdown
				isUnveiled: true,
				isGroup: true
			};
			this._enabledDocuments++; //add as an enabled document, the element should be hidden later if that's needed
			this.addGroup(this.groupElement); //add the group element to the dropdown, prepend group elements to make sure they are above the divider
		};

		/**
		 * Set the selected document page
		 * @param {String} pageId
		 */
		DocumentDropdownMenu.prototype.setSelectedDocumentPage = function (pageId) {
			if (this._selectedDocumentPage !== this.deselectElement && this._selectedDocumentPage !== null) {
				this.enableDocumentPage(this._selectedDocumentPage.name);
			} else if (this._selectedDocumentPage !== null) {
				this.deselectElement.content.html(this._deselectText);
				this.enableDocumentPage(this.deselectElement.name);
			}
			this._selectedDocumentPage = this.items[pageId];
			if (this._selectedDocumentPage !== undefined) {
				this._selectedDocumentElement.html(this._selectedDocumentPage.content);
				this._selectedDocumentElement.find(".thumbnail").attr("src", this._selectedDocumentPage.thumb);
			} else {
				this._selectedDocumentPage = null;
			}

			this.disableDocumentPage(pageId);
		};

		/**
		 * Set a temp content for the document selector, this will not be added to the dropdown list when getting deactivated.
		 * It sets the currently selected document page to null.
		 * @param {Object} docInfo
		 */
		DocumentDropdownMenu.prototype.setTempSelectedDocumentPage = function (docInfo) {
			this.t.d.docInfo = docInfo;
			this.t.d.thumbnailUrl = docInfo.thumbnailUrl;
			var html = this.t.getRenderedHtml();
			if (this._selectedDocumentPage !== this.deselectElement && this._selectedDocumentPage !== null) {
				this.enableDocumentPage(this._selectedDocumentPage.name);
			} else if (this._selectedDocumentPage !== null) {
				this.deselectElement.content.html(this._deselectText);
				this.enableDocumentPage(this.deselectElement.name);
			}
			this._selectedDocumentElement.html(html);
			this._selectedDocumentPage = null;
		};

		/**
		 * Is called when an item in the dropdown is clicked
		 * @private
		 * @param {String} pageId - the id of the document page
		 */
		DocumentDropdownMenu.prototype._itemClicked = function (pageId) {
			this.hide();
			this.setSelectedDocumentPage(pageId);
			this._onDocChange(pageId);
		};

		/**
		 * Disable a document in the dropdown list, the document will no longer be visible
		 * @param {String} pageId
		 */
		DocumentDropdownMenu.prototype.disableDocumentPage = function (pageId) {
			//needed to check if it wasn't visible before, make sure the enabledDocuments count stays correct
			if (this.isElementVisible(pageId)) {
				this.hideElement(pageId);
				this._enabledDocuments--;
				if (this.emptyListElement !== undefined && this._enabledDocuments <= 0) {
					this.showElement(this.emptyListElement.name);
					this.hideElement(this.dividerId);
				}
			}
		};

		/**
		 * Enable a document in the dropdown list
		 * @param {String} pageId
		 */
		DocumentDropdownMenu.prototype.enableDocumentPage = function (pageId) {
			//needed to check if it wasn't visible before, make sure the enabledDocuments count stays correct
			if (this.isElementVisible(pageId) !== undefined && !this.isElementVisible(pageId)
				//test if either the element is in no group or the pages that needs to be enabled belongs to the active group
				&& (this.items[pageId].group === undefined || this.isGroupOpen(this.items[pageId].group))) {
				this.showElement(pageId);
				this._enabledDocuments++;
				if (this.emptyListElement !== undefined && this._enabledDocuments > 0) {
					this.hideElement(this.emptyListElement.name);
					this.showElement(this.dividerId);
				}
			}
		};

		/**
		 * enable all document page of specific document type
		 * @param {DataConstants.documentPageType} docTypeConstant
		 */
		DocumentDropdownMenu.prototype.enableOnlyPagesWithDocType = function (docTypeConstant) {
			_.each(this.items, _.bind(function (item) {
				//make sure the element doesn't belong to a group, this will be handled later as all members of a group are of the same document type
				if (item.docType !== undefined && item.docType === docTypeConstant && item.group === undefined) {
					this.enableDocumentPage(item.name);
				} else if (item.docType !== undefined && item.group === undefined) {
					this.disableDocumentPage(item.name);
				}
			}, this));
			//set the enabled document type, only document pages of this type should now be enabled in the dropdown menu
			this._enabledDocType = docTypeConstant;

			//for the groups:
			_.each(this._elementGrouping, _.bind(function (group, groupName) { //iterate over all groups
				var itemOfGroup = this.items[group[0]]; //get an item of the group, will be used to test document type, so doesn't matter which element
				if (itemOfGroup !== undefined && itemOfGroup.docType !== docTypeConstant) { //if the document type is not the same
					this.hideElementGroup(groupName); //first hide all elements of the group, this makes the group element visible
					this.disableDocumentPage(groupName); //make sure to hide the group element
				} else if (itemOfGroup !== undefined && !this.items[groupName].isVisible && !itemOfGroup.isVisible) { //if both group element and all elements of the group are not visible
					this.hideElementGroup(groupName); //make sure at least the group element is visible (doc types are correct)
				}
			}, this));
			//deselect the selected document pages if they are not of the same type
			if (this._selectedDocumentPage !== null && docTypeConstant !== this._selectedDocumentPage.docType) {
				this.deselectCurrentPage(false);
			} else if (this._selectedDocumentPage !== null) {
				this.disableDocumentPage(this._selectedDocumentPage.name);
			}

			if (this._selectedDocumentPage !== null && this.deselectElement !== undefined && this.deselectElement !== this._selectedDocumentPage) {
				this.enableDocumentPage(this.deselectElement.name);
			}
		};

		/**
		 * Returns the unique id of the currently selected document page
		 * @returns {String|undefined} - unique id of the document page or undefined if there is no selected document page
		 */
		DocumentDropdownMenu.prototype.getSelectedDocumentPageId = function () {
			if (this._selectedDocumentPage !== null && this._selectedDocumentPage !== this.deselectElement) {
				return this._selectedDocumentPage.name;
			} else {
				return undefined;
			}
		};

		/**
		 * deselect the currently selected document page
		 * @param {Boolean} enableDocument - should the deselected document be added to the dropdownlist
		 */
		DocumentDropdownMenu.prototype.deselectCurrentPage = function (enableDocument) {
			if (enableDocument && this._selectedDocumentPage !== null) {
				this.enableDocumentPage(this._selectedDocumentPage.name);
			}
			if (this._deselectText !== "" && this._nothingSelectedText !== "") {
				this._selectedDocumentPage = this.deselectElement;
				this.disableDocumentPage(this.deselectElement.name);
				this.deselectElement.content.html(this._nothingSelectedText);
				this._selectedDocumentElement.html(this._selectedDocumentPage.content.clone());
			} else {
				this._selectedDocumentElement.html("");
				this._selectedDocumentPage = null;
			}
		};

		/**
		 * Hide all the elements belonging to a group, this will active the group element if there is no enabled document type
		 * @param {String} groupName
		 */
		DocumentDropdownMenu.prototype.hideElementGroup = function (groupName) {
			if (groupName !== undefined) {
				if (this._listElements[groupName] !== undefined) {
					this._listElements[groupName].first().find(".showAllPages").show();
					this._listElements[groupName].first().find(".hideAllPages").hide();
				} else {
					this.items[groupName].content.find(".showAllPages").show();
					this.items[groupName].content.find(".hideAllPages").hide();
				}
				this.items[groupName].isOpen = false;
				_.each(this._elementGrouping[groupName], _.bind(function (groupElementName) {
					this.disableDocumentPage(groupElementName); //first hide all the members of the group
				}, this));
				var elementOfGroup = this._elementGrouping[groupName][0]; //get a representative of the group
				//if the docType restriction for the dropdown is not the same as the docType of the group make sure to also hide the group element
				if (this._enabledDocType !== null && elementOfGroup !== undefined && this._enabledDocType !== this.items[elementOfGroup].docType) {
					this.disableDocumentPage(groupName);
				} else {
					this.enableDocumentPage(groupName);
				}
			}
		};

		/**
		 * Shows all the elements belonging to a group, this will hide the group element
		 * @param {String} groupName
		 */
		DocumentDropdownMenu.prototype.showElementGroup = function (groupName) {
			if (groupName !== undefined) {
				if (this._listElements[groupName] !== undefined) {
					this._listElements[groupName].first().find(".showAllPages").hide();
					this._listElements[groupName].first().find(".hideAllPages").show();
				} else {
					this.items[groupName].content.find(".showAllPages").hide();
					this.items[groupName].content.find(".hideAllPages").show();
				}
				this.items[groupName].isOpen = true;
				this._activeGroup = groupName;
				_.each(this._elementGrouping[groupName], _.bind(function (groupElementName) {
					this.enableDocumentPage(groupElementName);
				}, this));
			}
			this._unveil();
		};

		/**
		 * Hides all elements belonging to a group, will show all the group elements
		 */
		DocumentDropdownMenu.prototype.hideAllGroups = function () {
			_.each(this._elementGrouping, _.bind(function (group, groupName) {
				this.hideElementGroup(groupName);
			}, this));
		};

		/**
		 * Has the dropdown menu the document page with docId
		 * @param {String} docId
		 * @returns {Boolean}
		 */
		DocumentDropdownMenu.prototype.hasDocumentPage = function (docId) {
			return this.items[docId] !== undefined;
		};

		/**
		 * Has the dropdown menu the document group with groupId
		 * @param {String} groupId
		 * @returns {Boolean}
		 */
		DocumentDropdownMenu.prototype.hasDocumentGroup = function (groupId) {
			return this.items[groupId] !== undefined;
		};

		/**
		 * Does the dropdown menu have any groups
		 * @returns {Boolean}
		 */
		DocumentDropdownMenu.prototype.hasGroups = function () {
			return !_.isEmpty(this._elementGrouping);
		};

		/**
		 * Is the group with group name open
		 * @param {String} groupName
		 * @returns {Boolean}
		 */
		DocumentDropdownMenu.prototype.isGroupOpen = function (groupName) {
			return this.items[groupName].isOpen;
		};

		/**
		 * Show the document dropdown menu
		 */
		DocumentDropdownMenu.prototype.show = function () {
			DropdownMenu.prototype.show.call(this); //show the drop down menu
			this._unveil(); //unveil thumbnails if needed
			if (!this.scrollListenerRegistered) {
				this.popover.getContentDiv().scroll(_.bind(this.unveil, this)); //register scroll listener
				this.scrollListenerRegistered = true;
			}
		};

		/**
		 * Checks if the dropdown menu is open and gets all the elements that are visible in the list. If there are visible
		 * elements where the thumbnail has not yet been unveiled sets the src-element to the correct value so the document
		 * selector requests the thumbnail.
		 *
		 * @param {Boolean} [keepList] - should the previously constructed list of visible elements of the document selector be used, this happens when
		 * 								no elements become visible/hidden (when scrolling for example)
		 */
		DocumentDropdownMenu.prototype._unveil = function (keepList) {
			//first order all the elements of the lsit so all the elements are in order of appearance in the docSelector
			//if the list doesn't exist yet(is empty) or the existing list shouldn't be used the check to unveil thumbnails, construct the list
			if (this.indexList === undefined || this.indexList.length === 0 || !keepList) {
				var orderedListElements = [];
				
				//run over all the elements that have been added to the DOM
				_.each(this._listElements, _.bind(function (element, key) {
					var item = this.items[key]; //get the item that contains the data of this DOM-element
					if (item.isVisible) { //check if the element in the document controller is visible
						var groupIndex;
						if (item.type === "group") { //if the element is a group
							groupIndex = element.closest(".group").index(); // The closest .group element is the encompassing group element
							orderedListElements[groupIndex] = []; //add an array at the location to fill with all elements of this group
							orderedListElements[groupIndex][0] = item; //add the group element to the array as first element
						} else if (item.group !== undefined) { //the element is part of a group and index is relative to the div-element of the group
							groupIndex = element.closest(".group").index();
							orderedListElements[groupIndex][element.index()] = item; //add the element to the array of the group element
						} else { //the element is not a group nor belonging to a group
							orderedListElements[element.index()] = item;
						}
					}
				}, this));
				//to get all the elements as a 1 level deep array, flatten the array so elements of groups are placed at the correct location
				this.indexList = _.without(_.flatten(orderedListElements), undefined, null); //array in the correct order of appearance in the document selector
			}
			//only if there are elements in the list, document selector is not empty continue
			if (this.indexList.length > 0) {
				var scrollValue = 0; //how many pixels are the top of the element (not visible due to scroll)
				if (this.popover !== undefined) { //check if the dropdown is open and the popover is visible
					scrollValue = this.popover.getContentDiv().scrollTop();
				}
				var elementHeight = Math.ceil(this.menu.outerHeight(true) / this.indexList.length); // we can't rely on outerheight of a single element (it could be a group, and margins are collapsed on eachother), we do now how many elements we have and how much space they take in total :)
				var startIndex = Math.floor(scrollValue / elementHeight); //start index of the visible elements, how many elements are above and not visible

				var visibleHeight = this.popover.getContentDiv().innerHeight(); //calculate the height of the dropdown menu
				var endIndex = startIndex + Math.ceil(visibleHeight / elementHeight); //get the index of the last visible element
				if (endIndex > this.indexList.length - 1) { //make sure we do not move outside the indexlist array when going over visible elements
					endIndex = this.indexList.length - 1;
				}

				//run over all the visible elements
				for (var i = startIndex; i <= endIndex; i++) {
					var item = this.indexList[i];
					if (item) {
						var listElement = this._listElements[item.name];
						if (!item.isUnveiled && listElement !== undefined) { //check whether the thumbnail is already unveiled
							listElement.find(".thumbnail").attr("src", item.thumb); //unveil thumbnail
							item.isUnveiled = true;
						}
					}
				}
			}
		};

		/**
		 * Unveil thumbnails if this is needed.
		 */
		DocumentDropdownMenu.prototype.unveilThumbnails = function () {
			this._unveil();
		};

		/**
		 * Get an ordered list of the items as they appear in the dropdown menu
		 * @returns {Array.<Object>}
		 * @private
		 */
		DocumentDropdownMenu.prototype._getOrderedItemList = function () {
			if (this.menu) { //the menu list was openend, all items are in the DOM, 
				//use this since opened groups add documents to the end fo the itemStack
				return _.map(this.menu.find("li[data-name]"), function (itemElement) {
					return this.items[$(itemElement).attr("data-name")];
				}, this);
			} else {
				return this.itemStack;
			}
		};

		/**
		 * Get the page id of the first selectable item in the dropdown list
		 * @returns {String|null} Page Id, e.g. "0_1_2"
		 */
		DocumentDropdownMenu.prototype.getFirstSelectablePageId = function () {
			var listItems = this._getOrderedItemList();
			var index = 1;
			var item = listItems[index];
			while (index < listItems.length && item && item.isGroup) {
				item = listItems[++index];
			}
			if (index < listItems.length && item) {
				return item.name;
			} else {
				return null;
			}
		};

		/**
		 * Get the page id of the last selectable item in the dropdown list
		 * @returns {String|null} Page Id, e.g. "0_1_2"
		 */
		DocumentDropdownMenu.prototype.getLastSelectablePageId = function () {
			var listItems = this._getOrderedItemList();
			var item = _.last(listItems);
			var index = _.indexOf(listItems, item);
			while (index > 0 && item && item.isGroup) {
				item = listItems[--index];
			}
			if (item && index > 0) {
				return item.name;
			} else {
				return null;
			}
		};

		/**
		 * Get the page id of the next selectable item, relative to the currently active document page, in the dropdown list
		 * @returns {String|null} Page Id, e.g. "0_1_2"
		 */
		DocumentDropdownMenu.prototype.getNextItemId = function () {
			var listItems = this._getOrderedItemList();
			var selectedPageId = this.getSelectedDocumentPageId();
			var index = _.indexOf(listItems, this.items[selectedPageId]);
			var item = listItems[++index];
			while (index < listItems.length && item && item.isGroup) {
				item = listItems[++index];
			}
			if (item && index < listItems.length) {
				return item.name;
			} else {
				return null;
			}
		};

		/**
		 * Get the page id of the previous selectable item, relative to the currently active document page, in the dropdown list
		 * @returns {String|null} Page Id, e.g. "0_1_2"
		 */
		DocumentDropdownMenu.prototype.getPreviousItemId = function () {
			var listItems = this._getOrderedItemList();
			var selectedPageId = this.getSelectedDocumentPageId();
			var index = _.indexOf(listItems, this.items[selectedPageId]);
			var item = listItems[--index];
			while (index > 0 && item && item.isGroup) {
				item = listItems[--index];
			}
			if (item && index > 0) {
				return item.name;
			} else {
				return null;
			}
		};


		return DocumentDropdownMenu;
	});

define('web-viewer/layout/component/DocumentSelection',["web-viewer/core/PrivateChannel",
		"web-viewer/layout/component/DocumentDropdownMenu",
		"web-viewer/utils/ListenerUtil",
		"web-viewer/data/DataConstants",
		"underscore"
	],
	function (PrivateChannel,
		DocumentDropdownMenu,
		ListenerUtil,
		DataConstants,
		_) {
		"use strict";
		/**
		 * This component will take care of document selection.
		 * It contains a document selector for active documents and for difference document.
		 *
		 * @exports DocumentSelection
		 * @memberof Layout.Component
		 * @constructor
		 * @param {Core.ViewerFacade} f - The viewer facade
		 * @param {Compare.CompareModule} [compareModule] - compareModule, needed for difference document selector
		 * @param {Function} [onDocChangeCallback] - Called when active or difference document is changed
		 * @param {Boolean} [isMobile] - is mobile layout
		 * @param {Boolean} [isCompact] - if true version number is put behind the document (on the same line)
		 */
		var DocumentSelection = function (f, compareModule, onDocChangeCallback, isMobile, isCompact) {
			PrivateChannel.installTo(this, f, "documentSelection");
			this.f = f;
			ListenerUtil.mixin(this, f);

			//makes sure callbacks are only registered once when new documents are added
			this._callBacksAreRegistered = false;

			/**
			 * @Member {Function}
			 */
			this._onDocChangeCallback = onDocChangeCallback;

			/**
			 * @Member {compare.CompareModule}
			 */
			this.compareModule = compareModule;

			/**
			 * @member {DocumentDropdownMenu} dropdown menu for selecting the active document page
			 */
			this.activeDocPageSelector = null;

			/**
			 * @member {DocumentDropdownMenu} dropdown menu for selecting the difference document page
			 */
			this.differenceDocPageSelector = null;

			/**
			 * @member {DocumentDropdownMenu} dropdown menu for selecting the CAD overlay
			 */
			this.cadOverLaySelector = null;

			this.f.i18n.loadBundle("viewer", _.bind(function () {
				this.activeDocPageSelector = new DocumentDropdownMenu(f, _.bind(this.changeActivePage, this), this.f.t("EmptyDocumentList"), undefined, undefined, undefined, isMobile, isCompact);

				if (this.compareModule) {
					this.differenceDocPageSelector = new DocumentDropdownMenu(f, _.bind(this.changeDifferencePage, this), this.f.t("EmptyDocumentList"), this.f.t("EmptyDifferenceDocSelector"), this.f.t("DocumentListCompareTurnOff"), _.bind(function (deselectedPageId) {
						this.activeDocPageSelector.enableDocumentPage(deselectedPageId);

						// disable compare
						this.compareModule.activateModeByName();
					}, this), isMobile, isCompact);


					this.cadOverLaySelector = new DocumentDropdownMenu(f, _.bind(this.changeCadOverlay, this), this.f.t("EmptyDocumentList"), this.f.t("EmptyCadOverlayDocSelector"), this.f.t("DocumentListCadOverlayTurnOff"), _.bind(function (deselectedPageId) {
						// turn of CAD overlay
						this.f.getDocumentController().changeCadOverlay();
					}, this), isMobile, isCompact);
				}

				this.f.getDocumentController().whenDocumentsLoadedOrChange(this._whenDocumentsLoaded, this);
			}, this));
		};

		/**
		 * Get active document selector
		 * @return {DocumentDropdownMenu}
		 */
		DocumentSelection.prototype.getActiveDocumentSelector = function () {
			return this.activeDocPageSelector;
		};

		/**
		 * Get difference document selector
		 * @return {DocumentDropdownMenu}
		 */
		DocumentSelection.prototype.getDifferenceDocumentSelector = function () {
			return this.differenceDocPageSelector;
		};

		/**
		 * Get the CAD overlay document selector
		 * @returns {DocumentDropdownMenu} /
		 */
		DocumentSelection.prototype.getCadOverlayDocumentSelector = function () {
			return this.cadOverLaySelector;
		};


		/**
		 * Changes the active document page
		 * @param {String} id - unique id of the document page
		 */
		DocumentSelection.prototype.changeActivePage = function (id) {
			var newActivePage = this.f.getDocumentController().getDocumentPage(id);
			var activePage = this.f.getDocumentController().getActivePage();

			this._emit("changeActivePage", newActivePage, _.bind(function (isChanged) {
				if (isChanged && this.differenceDocPageSelector) {
					if (activePage !== undefined) {
						var pageId = activePage.getUniqueID();
						//make sure that the previous active document page can be selected as difference page
						this.differenceDocPageSelector.enableDocumentPage(pageId);
					}
					// reset difference when there is another type of document selected
					if (activePage.getDocument().getDocumentType() !== newActivePage.getDocument().getDocumentType()) {
						this.activeDocPageSelector.enableDocumentPage(this.differenceDocPageSelector.getSelectedDocumentPageId());
						this.compareModule.activateModeByName();
					}


					var docType = newActivePage.getDocument().getDocumentType();
					// enable as difference only documents of the same type
					this.differenceDocPageSelector.enableOnlyPagesWithDocType(docType);
					//the new active page can't be selected as difference document page
					this.differenceDocPageSelector.disableDocumentPage(id);
				}

				if (!isChanged) {
					this.activeDocPageSelector.setSelectedDocumentPage(this.f.getActivePage().getUniqueID());
				}
			}, this));
		};

		/**
		 * changes the difference document page
		 * @param {String} id - unique id of the document page
		 */
		DocumentSelection.prototype.changeDifferencePage = function (id) {
			var differencePage = this.f.getDocumentController().getDifferencePage();

			if (differencePage !== undefined) {
				var pageId = differencePage.getUniqueID();
				//make sure that the previous difference document page can be selected as active page
				this.activeDocPageSelector.enableDocumentPage(pageId);
			}
			this.activeDocPageSelector.disableDocumentPage(id);
			var newDiffPage = this.f.getDocumentController().getDocumentPage(id);
			this._emit("changeReferencePage", newDiffPage);
		};

		/**
		 * Changes the cad voerlay
		 * @param {String} id - unique id of the document page
		 */
		DocumentSelection.prototype.changeCadOverlay = function (id) {
			var docController = this.f.getDocumentController();
			var cadOverlayPage = docController.getDocumentPage(id);
			this._emit("changeCadOverlay", cadOverlayPage);

		};


		/**
		 * Called when documents are loaded or when new documents are added
		 * @param {Array.<AbstractDocument>} documents
		 */
		DocumentSelection.prototype._whenDocumentsLoaded = function (documents) {
			//this function is called when later on new documents are added or documents change (new version, new pages)
			//so make sure it takes this into account (check if page or group was already in the dropdown)
			_.each(documents, _.bind(function (document) {
				_.each(document.getAllDocumentVersions(), _.bind(function (docVersion) {
					if (docVersion && docVersion.getDocumentVersionID()) {
						if (docVersion.isMultiPage()) {
							var groupName = docVersion.getDocument().getIID() + "_" + docVersion.getVersionId() + "_Group";
							if (!this.activeDocPageSelector.hasDocumentGroup(groupName)) {
								//add a document group if it wasn't in the dropdown before, call loadPagesIfNeeded as callback to check wether pages still need to be loaded
								this.activeDocPageSelector.addDocumentGroup(groupName,
									// before show/hide
									_.bind(this._loadPagesIfNeeded, this, docVersion),
									// after show/hide
									_.bind(function () {
										// always disable the current visible active/diff page again if the whole group was shown again
										this.activeDocPageSelector.disableDocumentPage(this.activeDocPageSelector.getSelectedDocumentPageId());
										if (this.differenceDocPageSelector) {
											this.activeDocPageSelector.disableDocumentPage(this.differenceDocPageSelector.getSelectedDocumentPageId());
										}
									}, this));
							}
							if (this.differenceDocPageSelector && !this.differenceDocPageSelector.hasDocumentGroup(groupName)) {
								this.differenceDocPageSelector.addDocumentGroup(groupName,
									// before show/hide
									_.bind(this._loadPagesIfNeeded, this, docVersion),
									// after show/hide
									_.bind(function () {
										// always disable the current visible active/diff page again if the whole group was shown again
										this.differenceDocPageSelector.disableDocumentPage(this.differenceDocPageSelector.getSelectedDocumentPageId());
										this.differenceDocPageSelector.disableDocumentPage(this.activeDocPageSelector.getSelectedDocumentPageId());
									}, this));
							}
						}

						var pageCount = docVersion.getPageCount();
						for (var i = 1; i <= pageCount; i++) {
							var docPage = docVersion.getPage(i);
							if (docPage !== undefined) {
								var pageInfo = docPage.getInformationForDocumentSelector();

								var groupName;
								if (docVersion.isMultiPage()) {
									groupName = docVersion.getDocument().getIID() + "_" + docVersion.getVersionId() + "_Group";
								}
								if (!this.activeDocPageSelector.hasDocumentPage(pageInfo.pageId)) {
									this.activeDocPageSelector.addDocumentPage(pageInfo, groupName);
								}
								if (docPage.canBeComparedTo() && this.differenceDocPageSelector && !this.differenceDocPageSelector.hasDocumentPage(pageInfo.pageId) && !docPage.isBlankPage()) {
									this.differenceDocPageSelector.addDocumentPage(pageInfo, groupName);
								}

								if (this.cadOverLaySelector) {
									if (docPage.hasCad()) {
										this.cadOverLaySelector.addDocumentPage(pageInfo);
									} else if (docPage.hasLinkedPage()) {
										var linkedCadDocInfo = docPage.getLinkedPage().getInformationForDocumentSelector();
										linkedCadDocInfo.referencedFrom = docPage.getDocument().get("docname");
										this.cadOverLaySelector.addDocumentPage(linkedCadDocInfo);
									}
								}
							}
						}
					}
				}, this));
			}, this));
			//after elements have been added, unveil thumbnails if needed (doc selector might be open)
			this.activeDocPageSelector.unveilThumbnails();
			if (this.differenceDocPageSelector) {
				this.differenceDocPageSelector.unveilThumbnails();
			}
			this._registerCallbacksIfNeeded();
		};

		/**
		 * Registers the callbacks when the document selectors are initialized, makes sure they are only registered once.
		 * @private
		 */
		DocumentSelection.prototype._registerCallbacksIfNeeded = function () {
			if (!this._callBacksAreRegistered) {
				//To make sure first the document selectors are filled with data before the active page is initialized
				this.f.getDocumentController().whenActivePageChangedAndParametersAvailable(function (oldPage, page) {
					//check if the active document page was changed from somewhere else than the document selector
					if (this.activeDocPageSelector.getSelectedDocumentPageId() === undefined || page.getUniqueID() !== this.activeDocPageSelector.getSelectedDocumentPageId()) {
						if (page.getDocumentVersion().isMultiPage()) {
							this.activeDocPageSelector.hideAllGroups();
							var groupName = page.getDocument().getIID() + "_" + page.getDocumentVersion().getVersionId() + "_Group";
							this.activeDocPageSelector.showElementGroup(groupName);
						}
						this.activeDocPageSelector.setSelectedDocumentPage(page.getUniqueID());

						if (this.differenceDocPageSelector) {
							//if multi page first convert to graphics document type
							var docType = page.getDocument().getDocumentType();
							this.differenceDocPageSelector.enableOnlyPagesWithDocType(docType);
							this.differenceDocPageSelector.disableDocumentPage(page.getUniqueID());
							this.differenceDocPageSelector.hideAllGroups();

							if (page.getDocumentVersion().isPageList()) {
								_.each(page.getDocument().getAllDocumentVersions(), function (docVersion) {
									if (docVersion) {
										var diffPage = docVersion.getPage(page.getPagenum());
										if (diffPage) {
											this.differenceDocPageSelector.enableDocumentPage(diffPage.getUniqueID());
										}
									}
								}, this);
							}

							//for the first active page make sure to load pages of previous version for pagelist documents
							//only for this case is the oldPage === undefined
							if (oldPage === undefined && page.getDocumentVersion().isPageList()) {
								this.updateDocumentSelectorsForPageList(undefined, page);
							}
						}

					}

					if (this._onDocChangeCallback) {
						this._onDocChangeCallback();
					}
				}, this);
				if (this.differenceDocPageSelector) {
					this.f.getDocumentController().whenDifferencePageChangedAndParametersAvailable(function (oldPage, page) {
						//deselect the current page in the difference selector if reader spread is active (enabled) and a page is selected in the doc selector 
						var isReaderSpread = this.compareModule.isReaderSpreadActive();
						var activeMode = this.compareModule.getActiveMode();
						if (isReaderSpread && this.differenceDocPageSelector.getSelectedDocumentPageId() !== undefined && activeMode.isEnabled()) {
							this.differenceDocPageSelector.deselectCurrentPage(true);
							//if there is no active mode or the active mode is not enabled or the active mode is not reader spread
						} else if (activeMode === null || !activeMode.isEnabled() || !isReaderSpread) {
							if (page === undefined) {
								// set selected difference page to not selected
								this.differenceDocPageSelector.deselectCurrentPage(true);
								if (oldPage) {
									this.activeDocPageSelector.enableDocumentPage(oldPage.getUniqueID());
								}
							} else if (page.isBlankPage()) {
								// set selected difference page to not selected
								//this.differenceDocPageSelector.deselectCurrentPage(true);
								if (oldPage !== undefined) {
									this.activeDocPageSelector.enableDocumentPage(oldPage.getUniqueID());
								}
								this.differenceDocPageSelector.setTempSelectedDocumentPage(page.getInformationForDocumentSelector());
								this.f.emit("error.WARNING", this.f.i18n.t("ComparingWithBlankPage"));
							} else {
								//check if the difference document page is changed from somewhere other than the document selector
								if (this.activeDocPageSelector.getSelectedDocumentPageId() === undefined || page.getUniqueID() !== this.differenceDocPageSelector.getSelectedDocumentPageId()) {
									this.differenceDocPageSelector.setSelectedDocumentPage(page.getUniqueID());
									this.activeDocPageSelector.disableDocumentPage(page.getUniqueID());
									if (oldPage) {
										this.activeDocPageSelector.enableDocumentPage(oldPage.getUniqueID());
									}
								}
							}
						}
						if (this._onDocChangeCallback) {
							this._onDocChangeCallback();
						}
					}, this);
				}

				if (this.cadOverLaySelector) {
					this.f.getDocumentController().whenCadOverlayChangedAndParametersAvailable(function (oldPage, newPage) {
						this.cadOverLaySelector.deselectCurrentPage(true);
						if (newPage) {
							this.cadOverLaySelector.setSelectedDocumentPage(newPage.getUniqueID());
						}

						if (this._onDocChangeCallback) {
							this._onDocChangeCallback();
						}
					}, this);
				}

				this._callBacksAreRegistered = true;
			}
		};

		/**
		 * Set difference selector page to the given diff page. If undefined, the current page is de-selected and again added to the list of possible difference pages.
		 * If reader-spread is active, the page is deselected and added to the list also if diffpage is defined.
		 * @param {AbstractDocumentPage} [diffPage] - Diff page to set in the difference selector.
		 */
		DocumentSelection.prototype.setDifferenceSelectorPage = function (diffPage) {
			if (this.differenceDocPageSelector) {
				if (diffPage === undefined) {
					this.differenceDocPageSelector.deselectCurrentPage(true);
				} else {
					if (this.compareModule.isReaderSpreadActive()) {
						this.differenceDocPageSelector.deselectCurrentPage(true);
						this.activeDocPageSelector.enableDocumentPage(diffPage.getUniqueID());
					} else {
						this.differenceDocPageSelector.setSelectedDocumentPage(diffPage.getUniqueID());
						this.activeDocPageSelector.disableDocumentPage(diffPage.getUniqueID());
					}
				}
			}
		};

		/**
		 * Update the document selectors if the selected active document page is part of a page list document. Make sure to test if the document is
		 * a pagelist before calling this method! Since part is asynchronous, call this method before disabling/changing compare mode as takes
		 * it into account when changing to the correct difference document page. This only happens if compare was already active.
		 * @param {AbstractDocumentPage|undefined} activePage - if not provided, no previous pages will be disabled in the difference document selector
		 * @param {AbstractDocumentPage} newActivePage - the new active document page, used to enable the correct document pages in the difference document selector
		 */
		DocumentSelection.prototype.updateDocumentSelectorsForPageList = function (oldActivePage, newActivePage) {
			if (oldActivePage !== undefined) {
				var pageNumber = oldActivePage.getPagenum();
				var document = oldActivePage.getDocument();
				//run over all previous document versions of the document, to disable all pages that were enabled for the old active document page
				for (var i = 1; i < oldActivePage.getDocumentVersion().getVersionId(); i++) {
					var documentVersion = document.getDocumentVersion(i);
					if (documentVersion !== undefined && documentVersion.hasPage(pageNumber)) { //it is possible that the document version/page was not (yet) loaded
						var pageID = documentVersion.getPage(pageNumber).getUniqueID(); //unique id is used as key for the document selector
						this.differenceDocPageSelector.disableDocumentPage(pageID); //disable the document page 
					}
				}
			}
			//to make sure that the correct document page is set as difference page, if before changing active document page, a compare mode was active
			//this is needed because of asynchronous call to load version of the new active document page
			var wasComparing = false;
			if (this.compareModule) {
				wasComparing = this.compareModule.getActiveMode() !== null && !this.compareModule.isReaderSpreadActive() && !newActivePage.getLinkedComparePage();
			}

			//call to the server to request previous version of the document that has pages with the same page number as the active document page
			newActivePage.getDocument().loadVersionsForDocumentPage(newActivePage, _.bind(function (pages) {
				//execute callback for when the pages have been added to the document controller
				_.each(pages, _.bind(function (page) { //run over each pages to add to the difference document selector
					if (page) {
						if (this.differenceDocPageSelector.hasDocumentPage(page.getUniqueID())) { //first check if the page wasn't already added to the document selector
							this.differenceDocPageSelector.enableDocumentPage(page.getUniqueID()); //enable if that is the case
						} else {
							var docInfo = page.getInformationForDocumentSelector();
							docInfo.prepend = true; //pages need to be prepended to make sure they are added to the beginning of the document selector
							docInfo.docType = DataConstants.documentPageType.PAGELIST; //change docType to PageList to make sure they are not hidden by the document selector
							docInfo.pageCount = null; //set pageCount to null, this is not correct for page list documents as they don't load all pages of a version at the same time
							this.differenceDocPageSelector.addDocumentPage(docInfo);
						}
					}
				}, this));
				//check if the comparing was active before, if so set the difference document page to the same page of the last version
				if (wasComparing) {
					this.differenceDocPageSelector.setSelectedDocumentPage(_.last(pages).getUniqueID()); //_.last gets the page of the last version 
					this.changeDifferencePage(_.last(pages).getUniqueID());
				}
			}, this));
		};

		/**
		 * Load pages of the given document version if these pages are not yet loaded, this to prevent loading at initialization
		 * @private
		 * @param {AbstractDocumentVersion} docVersion - document version to load pages for
		 */
		DocumentSelection.prototype._loadPagesIfNeeded = function (docVersion) {
			if (docVersion.isMultiPage() && docVersion.getPageCount() <= 1) {
				this.f.getDocumentController().loadDocumentPages(docVersion.getDocument().getIID(), docVersion.getVersionId());
			}
		};

		/**
		 * Add a newly created document page in the cad overlay selector and remove an old cad overlay (linked document pages).
		 * It makes the newly added document page as the active (selected) document page.
		 * @param {AbstractDocumentPage} graphicsPage
		 * @param {String} oldCadOverlayId
		 */
		DocumentSelection.prototype.setNewlyCreatedCadOverlay = function (graphicsPage, oldCadOverlayId) {
			this.cadOverLaySelector.removeDocumentPage(oldCadOverlayId);
			var linkedCadPage = graphicsPage.getLinkedPage();
			if (linkedCadPage) {
				var linkedCadDocInfo = linkedCadPage.getInformationForDocumentSelector();
				linkedCadDocInfo.referencedFrom = graphicsPage.getDocument().get("docname"); //make sure the link is displayed in the document selector
				this.cadOverLaySelector.addDocumentPage(linkedCadDocInfo);
				if (this.f.getDocumentController().getCadOverlay()) {
					this.cadOverLaySelector.setSelectedDocumentPage(linkedCadDocInfo.pageId);
				}
			}
		};

		/**
		 * Get the first selectable page id
		 * @returns {String|null}
		 */
		DocumentSelection.prototype.getFirstSelectablePageId = function () {
			return this.activeDocPageSelector.getFirstSelectablePageId();
		};

		/**
		 * Get the last selectable page id
		 * @returns {String|null}
		 */
		DocumentSelection.prototype.getLastSelectablePageId = function () {
			return this.activeDocPageSelector.getLastSelectablePageId();
		};

		/**
		 * Get the next selectable page id, relative to the currently selected page in the active page selector
		 * @returns {String|null}
		 */
		DocumentSelection.prototype.getNextSelectablePageId = function () {
			return this.activeDocPageSelector.getNextItemId();
		};

		/**
		 * Get the previous selectable page id, relative to the currently selected page in the active page selector
		 * @returns {String|null}
		 */
		DocumentSelection.prototype.getPreviousSelectablePageId = function () {
			return this.activeDocPageSelector.getPreviousItemId();
		};

		return DocumentSelection;
	});


define('tpl!web-viewer/documentInfo/DocumentInfoWidget', function(){return function(d){
var __t,__p='',__j=Array.prototype.join,print=function(){__p+=__j.call(arguments,'');};
__p+='<span>\r\n	'+
((__t=(d.i18n('WCProject')))==null?'':_.escape(__t))+
' <strong>'+
((__t=(d.project))==null?'':_.escape(__t))+
'</strong>\r\n</span>\r\n<span>\r\n	'+
((__t=(d.i18n('WCDocument')))==null?'':_.escape(__t))+
'\r\n	<span class="'+
((__t=(d.documentClass))==null?'':_.escape(__t))+
'">\r\n		<strong>'+
((__t=(d.document))==null?'':_.escape(__t))+
'</strong> '+
((__t=(d.i18n('WCHistVersion')))==null?'':_.escape(__t))+
' '+
((__t=(d.version))==null?'':_.escape(__t))+
'\r\n	</span>\r\n<span class="activeDocumentInfo">\r\n	\r\n	</span>\r\n';
 if(d.diffDocument){ 
__p+='\r\n	/ <span class="'+
((__t=(d.diffClass))==null?'':_.escape(__t))+
'">\r\n			<strong>'+
((__t=(d.diffDocument))==null?'':_.escape(__t))+
'</strong> '+
((__t=(d.i18n('WCHistVersion')))==null?'':_.escape(__t))+
' '+
((__t=(d.diffVersion))==null?'':_.escape(__t))+
'\r\n	   </span>\r\n	<span class="referenceDocumentInfo">\r\n	\r\n	</span>\r\n	';
 } 
__p+='\r\n		</span>\r\n\r\n		';
 if (d.showPageControls) { 
__p+='\r\n			<span class="pageControls">\r\n	<a name="firstPage" class="'+
((__t=(d.firstPageClass))==null?'':_.escape(__t))+
'" tooltip="'+
((__t=(d.i18n('FirstPageTT')))==null?'':_.escape(__t))+
'">\r\n		<i class="icon-WCR_Page-First"></i>\r\n	</a>\r\n	<a name="previousPage" class="'+
((__t=(d.previousPageClass))==null?'':_.escape(__t))+
'" tooltip="'+
((__t=(d.i18n('PreviousPageTT')))==null?'':_.escape(__t))+
'">\r\n		<i class="icon-WCR_Page-Previous"></i>\r\n	</a>\r\n	<input name="currentPage" class="currentPage" type="text" value="'+
((__t=(d.i18n('PageNumberOfCount', d.pageNumber, d.pageCount)))==null?'':_.escape(__t))+
'" size="'+
((__t=(d.i18n('PageNumberOfCount', d.pageNumber, d.pageCount).length))==null?'':_.escape(__t))+
'" tooltip="'+
((__t=(d.i18n('PageTT')))==null?'':_.escape(__t))+
'"></input>\r\n	<a name="nextPage" class="'+
((__t=(d.nextPageClass))==null?'':_.escape(__t))+
'" tooltip="'+
((__t=(d.i18n('NextPageTT')))==null?'':_.escape(__t))+
'">\r\n		<i class="icon-WCR_Page-Next"></i>\r\n	</a>\r\n	<a name="lastPage" class="'+
((__t=(d.lastPageClass))==null?'':_.escape(__t))+
'" tooltip="'+
((__t=(d.i18n('LastPageTT')))==null?'':_.escape(__t))+
'">\r\n		<i class="icon-WCR_Page-Last"></i>\r\n	</a>\r\n</span>\r\n			';
 } 
__p+='\r\n\r\n				<span class="user">\r\n	'+
((__t=(d.i18n('WCHistUser')))==null?'':_.escape(__t))+
' <strong>'+
((__t=(d.user))==null?'':_.escape(__t))+
'</strong>\r\n</span>';
return __p;
}});
define('web-viewer/layout/component/DynamIcon',["component/tooltip/Tooltip",
		"jquery",
		"underscore"
	],
	function (Tooltip,
		$,
		_) {
		"use strict";

		/**
		 * Dynamic Icon makes it possible to save all possible icons by key and change the icon whithout the need
		 * to create a new DOM-element or rerender an entire template because the icon is part of it. Every added icon
		 * can have a seperate tooltip. Icons can be composed of a container- and sub-icon which are rendered on top
		 * of each other. Do not use .element! use the getElement-method to get the DOM-object of the icon.
		 *
		 * @exports
		 * @constructor
		 * @param {Core.ViewerFacade} f - The viewer facade
		 * @param {String} keyOrName - The name of the DynamIcon or the key of the given icon
		 * @param {String} iconClass - default icon that is used for the DynamIcon
		 * @param {String} [subIconClass] - default subicon that is used for the DynamIcon
		 */
		var DynamIcon = function (f, keyOrName, iconClass, subIconClass) {
			this.f = f;

			this._element = $("<span>").addClass("DynamIcon");

			this._icon = $("<i/>").addClass("icon");

			//are the icons composed with container- and sub-icons
			this._subIconsUsed = subIconClass ? true : false;

			if (this._subIconsUsed) {
				this._icon.addClass("containerIcon");
				this._subIcon = $("<i/>").addClass("icon subIcon");
				this._icon.append(this._subIcon);
			}

			this._tooltip = null;

			this._possibleIcons = {};

			this._possibleSubIcons = {};

			this._activeIconKey = null;

			this._tooltips = {};

			if (subIconClass) {
				this._possibleSubIcons[keyOrName] = subIconClass;
			}

			if (iconClass) {
				this._possibleIcons[keyOrName] = iconClass;
				this.setIcon(keyOrName);
			}

			this._element.append(this._icon);
		};

		/**
		 * Set which icon needs to be displayed
		 * @param {String} key
		 */
		DynamIcon.prototype.setIcon = function (key) {
			if (this._activeIconKey) { //first remove the class of the currently active icon
				this._icon.removeClass(this._possibleIcons[this._activeIconKey]);
				if (this._subIconsUsed) { //if subicons are used also remove the class of the subicon DOM-element
					this._subIcon.removeClass(this._possibleSubIcons[this._activeIconKey]);
				}
			}
			this._icon.addClass(this._possibleIcons[key]);
			if (this._subIconsUsed) {
				this._subIcon.addClass(this._possibleSubIcons[key]);
			}
			this._activeIconKey = key;
			this._setTooltip(key);
		};

		/**
		 * Add a new icon, [subIcon] and tooltip to the map
		 * @param {String} key
		 * @param {String} iconClass
		 * @param {String} [subIconClass]
		 */
		DynamIcon.prototype.addIcon = function (key, iconClass, subIconClass) {
			this._possibleIcons[key] = iconClass;
			if (subIconClass) {
				this._possibleSubIcons[key] = subIconClass;
			}
		};

		/**
		 * Set Tooltip for icon with given key
		 * @param {Stirng}		key
		 * @param {String}         tooltipOrBundle - tooltip to show if langKey is undefined or language bundle
		 * @param {String}         [langKey]       - not required
		 * @param {Array.<String>} [stringArgs]    - not required, parameters that need to be filled in the language string
		 */
		DynamIcon.prototype.addTooltip = function (key, tooltipOrBundle, langKey, stringArgs) {
			this._tooltips[key] = {
				tooltipOrBundle: tooltipOrBundle,
				langKey: langKey,
				stringArgs: stringArgs
			};
			if (key === this._activeIconKey) {
				this._setTooltip(key);
			}
		};

		/**
		 * Set which tooltip needs to be displayed on the currently active icon
		 * @param {String} key
		 * @private
		 */
		DynamIcon.prototype._setTooltip = function (key) {
			var tooltip = this._tooltips[key];
			if (tooltip) {
				if (this._tooltip === null) {
					this._tooltip = new Tooltip(this.f.i18n, this._element, this.f.getContext(), this.f.getContext(), this.f.isMobile(), tooltip.tooltipOrBundle, tooltip.langKey, tooltip.stringArgs);
				} else {
					this._tooltip.setTooltipContent(tooltip.tooltipOrBundle, tooltip.langKey, tooltip.stringArgs);
				}
			}
		};

		/**
		 * Show the icon
		 * @param {String} key of the icon to be shown
		 */
		DynamIcon.prototype.show = function (key) {
			if (key) {
				this.setIcon(key);
			}
			this._element.show();
		};

		/**
		 * Hide the button
		 */
		DynamIcon.prototype.hide = function () {
			this._element.hide();
		};

		/**
		 * Get the element of the icon
		 * @returns {JQueryObj}
		 */
		DynamIcon.prototype.getElement = function () {
			//the tooltip is not rendered correctly if the icon was part of a template (all listeners get removed on its rerender)
			if (this._tooltip) { //if the tooltip is present make sure to refresh the mouse-listeners
				this._tooltip.refereshListeners();
			}
			//IE doesn't like dynamicons :(, and decides to destroys branches of the DOM-tree on rerender of the template
			if (this._element[0].children.length === 0) { //re-construct the structure of DOM-elements
				this._icon.append(this._subIcon);
				this._element.append(this._icon);

			}
			return this._element;
		};

		return DynamIcon;
	});

define('web-viewer/documentInfo/DocumentInfoIcons',[
		"web-viewer/cad/CadConstants",
		"web-viewer/utils/ListenerUtil",
		"web-viewer/layout/component/DynamIcon",
		"jquery",
		"underscore"
	],
	function (
		CadConstants,
		ListenerUtil,
		DynamIcon,
		$,
		_) {
		"use strict";

		/**
		 * View that displays information icons of the supplied document page (CAD-file). The icons change whenever parameters
		 * of the page change and if the viewport rotates or flips.
		 *
		 * @memberof DocumentInfoModule
		 * @exports DocumentInfoIcons
		 * @class
		 * @constructor
		 * @param {Core.ViewerFacade} f
		 */
		var DocumentInfoIcons = function (f) {
			ListenerUtil.mixin(this, f);
			this.f = f;

			/**
			 * @member {AbstractDocumentPage}
			 */
			this._documentPage = null;

			/**
			 * @member {JQueryObj} - wrapper DOM element for the icons
			 */
			this._cadInfoIcons = $("<span>").addClass("activeDocumentInfo");

			/**
			 * @member {ViewportModule} - viewport module to fetch rotation/flip information of the world
			 */
			this._viewport = null;

			/**
			 *  Information icons for the Document page:
			 */
			this._defaultSide = new DynamIcon(this.f, CadConstants.DefaultSide.OUTSIDE, "icon-WCR_CAD-Outside-cont", "icon-WCR_CAD-Outside-sub");
			this._defaultSide.addIcon(CadConstants.DefaultSide.INSIDE, "icon-WCR_CAD-Inside-cont", "icon-WCR_CAD-Inside-sub");

			this._grainFluteDirection = new DynamIcon(this.f, CadConstants.GrainFluteDirection.VERTICAL, "icon-WCR_CAD-Direction-V");
			this._grainFluteDirection.addIcon(CadConstants.GrainFluteDirection.HORIZONTAL, "icon-WCR_CAD-Direction-H");

			this._dieSide = new DynamIcon(this.f, CadConstants.DieSide.BACKSIDE, "icon-WCR_CAD-Die-cont", "icon-WCR_CAD-DieBack-sub");
			this._dieSide.addIcon(CadConstants.DieSide.KNIFESIDE, "icon-WCR_CAD-Die-cont", "icon-WCR_CAD-DieKnife-sub");

			this._defaultSide.addTooltip(CadConstants.DefaultSide.OUTSIDE, "viewer", "OutsideDefaultSideTT");
			this._defaultSide.addTooltip(CadConstants.DefaultSide.INSIDE, "viewer", "InsideDefaultSideTT");
			this._grainFluteDirection.addTooltip(CadConstants.GrainFluteDirection.VERTICAL, "viewer", "VerticalGrainFluteTT");
			this._grainFluteDirection.addTooltip(CadConstants.GrainFluteDirection.HORIZONTAL, "viewer", "HorizontalGrainFluteTT");
			this._dieSide.addTooltip(CadConstants.DieSide.BACKSIDE, "viewer", "BackSideTT");
			this._dieSide.addTooltip(CadConstants.DieSide.KNIFESIDE, "viewer", "KnifeSideTT");

			//save the viewport module which can be used to fetch rotation/flip information of the document page
			this.f.whenModuleAvailable("viewport", function (viewportModule) {
				this._viewport = viewportModule;
				this.updateIcons();
			}, this);

			//register several listeners to update the icons (rotation/flip)
			this._registerListener("doc.parameters.changed", this.updateIcons, this);
			this._registerListener("transform.viewportWidget.rotated", this.updateIcons, this);
			this._registerListener("transform.viewportWidget.flipped", this.updateIcons, this);

		};

		/**
		 * Update the information icons.
		 */
		DocumentInfoIcons.prototype.updateIcons = function () {
			//first check if the rotation/flip state of the document and the world causes the icons to change
			var isSideSwitched = false;
			var isGrainFluteSwitched = false;
			var isDieSideSwitched = false;
			if (this._viewport && this._documentPage) {
				var pageRotation = (this._viewport.getWorld().getRotation() + this._documentPage.getRotation()) % 360;
				isGrainFluteSwitched = (pageRotation === 90 || pageRotation === 270);
				isSideSwitched = this._viewport.getWorld().isFlip() !== this._documentPage.isFlipped(); //logical XOR operation
				isDieSideSwitched = this._viewport.getWorld().isFlip() !== this._documentPage.isFlipped();
			}

			//update the default side icon
			if (this._documentPage && this._documentPage.get("defaultSide")) {
				var defaultSide = this._documentPage.get("defaultSide");

				if (isSideSwitched) {
					defaultSide = defaultSide == CadConstants.DefaultSide.OUTSIDE ? CadConstants.DefaultSide.INSIDE : CadConstants.DefaultSide.OUTSIDE;
				}
				//show the correct icon
				this._defaultSide.show(defaultSide);
			} else {
				this._defaultSide.hide();
			}
			//update the flute/grain direction icon
			if (this._documentPage && this._documentPage.get("grainDirection")) {
				var grainFluteDirection = this._documentPage.get("grainDirection");

				if (isGrainFluteSwitched) {
					grainFluteDirection = grainFluteDirection == CadConstants.GrainFluteDirection.VERTICAL ? CadConstants.GrainFluteDirection.HORIZONTAL : CadConstants.GrainFluteDirection.VERTICAL;
				}

				this._grainFluteDirection.show(grainFluteDirection);
			} else {
				this._grainFluteDirection.hide();
			}
			//update the die side icon (this is only for mfg-files)
			if (this._documentPage && this._documentPage.get("dieSide")) {
				var dieSide = this._documentPage.get("dieSide");

				if (isDieSideSwitched) {
					dieSide = dieSide == CadConstants.DieSide.KNIFESIDE ? CadConstants.DieSide.BACKSIDE : CadConstants.DieSide.KNIFESIDE;
				}

				this._dieSide.show(dieSide);
			} else {
				this._dieSide.hide();
			}
		};

		/**
		 * Set a new document page.
		 * @param {AbstractDocumentPage} documentPage
		 */
		DocumentInfoIcons.prototype.setDocumentPage = function (documentPage) {
			this._documentPage = documentPage;
			this.updateIcons();
		};

		/**
		 * Get the page icons to be displayed.
		 * @returns {JQueryObj}
		 */
		DocumentInfoIcons.prototype.getPageIcons = function () {
			var documentInfoIcons = $("<span>");
			documentInfoIcons.append(this._grainFluteDirection.getElement()).append(this._defaultSide.getElement()).append(this._dieSide.getElement());
			return documentInfoIcons;
		};

		return DocumentInfoIcons;
	});

define('web-viewer/documentInfo/DocumentInfoWidget',["web-viewer/layout/AbstractWidget",
        "Template",
        "tpl!web-viewer/documentInfo/DocumentInfoWidget",
        "web-viewer/documentInfo/DocumentInfoIcons",
        "component/toolbar/ToolbarComponent",
        "component/toolbar/ButtonGroup",
        "web-viewer/layout/component/MiniButton",
        "web-viewer/layout/component/ModalPopup",
        "jquery",
        "underscore",
        "web-viewer/compare/CompareConstants",
        "web-viewer/utils/ListenerUtil",
        "web-viewer/utils/ViewerUtils",
        "component/tooltip/Tooltip",
        "web-viewer/layout/LayoutConstants",
        "web-viewer/data/DataConstants"
    ],
    function (AbstractWidget,
        Template,
        tpl,
        DocumentInfoIcons,
        ToolbarComponent,
        ButtonGroup,
        MiniButton,
        ModalPopup,
        $,
        _,
        CompareConstants,
        ListenerUtil,
        ViewerUtils,
        Tooltip,
        LayoutConstants,
        DataConstants) {
        "use strict";

        /**
         * @constant {Number} the speed to render the widget
         */
        var RENDER_SPEED = 40;

        /**
         * @exports DocumentInfoWidget
         * @augments Layout.AbstractWidget
         * @class The DocumentInfoWidget displays the currently loaded document and logged in user
         * @constructor
         * @mixes {Utils.ListenerUtilMixin}
         * @param {Core.ViewerFacade} f
         */
        var DocumentInfoWidget = function DocumentInfoWidget(f) {
            AbstractWidget.call(this, f, LayoutConstants.Widget.DOCUMENTINFO);

            ListenerUtil.mixin(this, f);

            this.templateContext = $("<div>", {
                'class': "infoSection"
            });
            this.buttonsComponent = new ToolbarComponent("buttonsComponent", f);
            this.isListeningToCompare = false;
            this.diffMode = -1;
            this.compareMode = null;

            this._activePageInfoIcons = new DocumentInfoIcons(f);
            this._referencePageInfoIcons = new DocumentInfoIcons(f);

            var returnURL = f.getProperty("returnurl");
            var javaViewerURL = f.getProperty("javaViewerURL");

            var buttonGroup;
            if (returnURL || javaViewerURL) {
                buttonGroup = new ButtonGroup("buttonsGroup");
                buttonGroup.element.addClass("pull-right");
                this.buttonsComponent.addButtonGroup(buttonGroup);
            }

            // If return URL set, add close viewer button
            if (returnURL) {
                var returnButton = new MiniButton(f, "exit", "icon-WCR_Close12", true, function () {
                    f.emit("viewer.request.close", returnURL);
                });
                returnButton.element.addClass("pull-right");
                returnButton.setTooltip("viewer", "exitViewerBtnTT");
                buttonGroup.addButton(returnButton);
            }

            //show a help button
            var helpButton = new MiniButton(f, "help", "icon-WCR_Menu-Help", true, function (e) {
                var helpModule = this.f.getModule("help");
                if (helpModule) {
                    helpModule.openHelpPages();
                }
            });
            helpButton.element.addClass("pull-right");
            helpButton.setTooltip("viewer", "HelpTT");
            helpButton.hide();

            //show the shortcuts help button
            var shortcutsButton = new MiniButton(f, "shortcuts", "icon-WCR_KeyboardShortcuts-keyboard", true, function (e) {
                var helpModule = this.f.getModule("help");
                if (helpModule) {
                    helpModule.openShortcutsPopup();
                }
            });
            shortcutsButton.element.addClass("pull-right");
            shortcutsButton.setTooltip("viewer", "ShortcutsTT");
            shortcutsButton.hide();

            buttonGroup.addButton(helpButton);
            buttonGroup.addButton(shortcutsButton);
            this.f.whenModuleAvailable("help", function () {
                helpButton.show(); // show if help module available
                shortcutsButton.show();
            }, this);

            // If the javaViewerURL is set and the browser supports java, add the Go To Java Viewer button
            if (javaViewerURL && navigator.javaEnabled()) {
                var goToJavaButton = new MiniButton(f, "javaviewer", "icon-WCR_JavaViewer", false, _.bind(function (e) {
                    // Check if java viewer can open this type of document
                    var docType = this.f.getActiveDocument().getDocumentType();
                    if (docType === DataConstants.documentPageType.CAD ||
                        docType === DataConstants.documentPageType.GRAPHICS ||
                        docType === DataConstants.documentPageType.PAGELIST) {
                        if (e.ctrlKey || e.metaKey || e.which === 2) {
                            window.open(javaViewerURL, "_blank");
                        } else {
                            window.location = javaViewerURL;
                        }
                    } else {
                        this._showJavaViewerIncompatiblePopup();
                    }
                }, this));
                goToJavaButton.element.addClass("pull-right");
                goToJavaButton.setTooltip("viewer", "goToJavaViewerBtnTT");
                buttonGroup.addButton(goToJavaButton);
            }

            // Viewer options button
            var resetLayoutButton = new MiniButton(f, "resetLayout", "icon-WCR_ResetLayout", true, _.bind(function () {
                this._resetLayout();
            }, this));
            resetLayoutButton.element.addClass("pull-right");
            resetLayoutButton.setTooltip("viewer", "ResetLayout");
            buttonGroup.addButton(resetLayoutButton);
            this._resetLayoutPopup = null;

            // Show button to switch to mobile layout (if the device has touch)
            this.f.requestModule("featureDetector", _.bind(function (featureDetector) {
                if (featureDetector.isMobile() || featureDetector.hasTouch()) {
                    var switchToMobileButton = new MiniButton(this.f, "switchToMobile", "icon-WCR_Mobile", true, _.bind(function (e) {
                        this.f.switchLayout(LayoutConstants.LayoutType.MOBILE);
                    }, this));
                    switchToMobileButton.setTooltip("viewer", "SwitchToMobile");
                    buttonGroup.prependButton(switchToMobileButton);
                }
            }, this));

            // initialize template
            this.t = new Template(f.i18n, tpl);

            this.render = _.throttle(_.bind(this._render, this), RENDER_SPEED);
            // load language if needed
            this.f.loadBundle("viewer", this.render, this);
            this.f.getDocumentController().whenActiveOrDifferencePageChangedAndParametersAvailableOrChange(this.render, this);

            this.f.whenModuleAvailable("print", function (printModule) {
                var printButton = new MiniButton(f, "print", "icon-WCR_Print", true, _.bind(function () {
                    if (this.compareMode === CompareConstants.mode.BLINKING) {
                        this.f.emit("error.WARNING", "Cannot print when blinking compare mode is active.");
                    } else {
                        printModule.openPrintPopup();
                    }
                }, this));
                printButton.element.addClass("pull-right");
                printButton.setTooltip("viewer", "PrintTT");
                buttonGroup.addButton(printButton);
            }, this);

            this.f.whenModuleAvailable("compare", function (compareModule) {
                this._registerListener("changed.diffMode", function (oldValue, newValue) {
                    this.diffMode = newValue;
                    this.render();
                }, this, compareModule);
                this._registerListener("changed.mode", function (oldMode, newMode) {
                    if (newMode === null) {
                        this.compareMode = null;
                    } else {
                        this.compareMode = newMode.getName();
                    }
                }, this, compareModule);
                this.diffMode = compareModule.getDiffMode();
            }, this);

            // Page controls
            this.t.bind("click", "a[name='firstPage']", this._firstPage, this);
            this.t.bind("click", "a[name='previousPage']", this._previousPage, this);
            this.t.bind("click", "a[name='nextPage']", this._nextPage, this);
            this.t.bind("click", "a[name='lastPage']", this._lastPage, this);
            this.t.bind("mousedown", "input[name='currentPage']", this._currentPageClick, this);
            this.t.bind("keydown", "input[name='currentPage']", this._currentPageEnter, this);

            // add tooltips
            this.whenContextAvailable(function () {
                this.tooltip = new Tooltip(this.f.i18n, this.context, this.f.getContext(), this.f.getContext(), this.f.isMobile(), "");
                this.tooltip.disableTooltip();
                // filter on all elements with attribute tooltip that are not disabled
                this.t.bind("mouseover", "[tooltip]:not('.disabled')", function (source, event) {
                    this.tooltip.setTooltipContent($(source).attr("tooltip"));
                    this.tooltip.context = $(source);
                    this.tooltip.show();
                }, this);
                // filter on all elements with attribute tooltip that are not disabled
                this.t.bind("mouseout", "[tooltip]:not('.disabled')", function (source, event) {
                    this.tooltip.hide();
                }, this);
            }, this);
        };

        DocumentInfoWidget.prototype = Object.create(AbstractWidget.prototype);
        DocumentInfoWidget.prototype.constructor = DocumentInfoWidget;
        DocumentInfoWidget.widgetName = LayoutConstants.Widget.DOCUMENTINFO;

        /**
         * @override
         */
        DocumentInfoWidget.prototype.setContext = function (context) {
            AbstractWidget.prototype.setContext.call(this, context);
            this.context.append($("<div>").append(this.templateContext, this.buttonsComponent.element));
            this.context.addClass("enableTextSelection");
            this.t.setContext(this.templateContext);
            this.context.addClass("documentInfoWidget");
            this.render();
        };

        /**
         * Set the needed data for the widget
         */
        DocumentInfoWidget.prototype._render = function () {
            var docController = this.f.getDocumentController();
            var activePage = docController.getActivePage();
            var diffPage = docController.getDifferencePage();
            var overlay = docController.getCadOverlay();

            // reset template vars
            this.t.d.diffDocument = "";
            this.t.d.diffVersion = "";
            this.t.d.diffClass = "";
            this.t.d.documentClass = "";

            if (activePage) {
                // fill in active page details
                var doc = activePage.getDocument();
                this.t.d.project = doc.get("projectname") || "";
                this.t.d.document = doc.get("docname") || "";
                this.t.d.version = activePage.getDocumentVersion().get("docversion") || "";
                if (activePage.getDocumentVersion().get("docRevision")) {
                    this.t.d.version += "(" + activePage.getDocumentVersion().get("docRevision") + ")";
                }
                this.t.d.showPageControls = activePage.getDocumentVersion().isMultiPage();
                this.t.d.pageNumber = activePage.getPagenum();
                this.t.d.pageCount = activePage.getDocumentVersion().getPageCount();
                this.t.d.firstPageClass = "mini-btn" + (activePage.getPagenum() <= activePage.getDocumentVersion().getFirstPage().getPagenum() ? " disabled" : "");
                this.t.d.previousPageClass = "mini-btn" + (activePage.getPagenum() <= activePage.getDocumentVersion().getFirstPage().getPagenum() ? " disabled" : "");
                this.t.d.nextPageClass = "mini-btn" + (activePage.getPagenum() >= activePage.getDocumentVersion().getLastPage().getPagenum() ? " disabled" : "");
                this.t.d.lastPageClass = "mini-btn" + (activePage.getPagenum() >= activePage.getDocumentVersion().getLastPage().getPagenum() ? " disabled" : "");

                // if there is a diff page, show this information
                if (diffPage !== undefined && this.compareMode !== CompareConstants.mode.READERSPREAD) {
                    doc = diffPage.getDocument();
                    this.t.d.diffDocument = doc.get("docname") || "";
                    this.t.d.diffVersion = diffPage.getDocumentVersion().get("docversion") || "";
                    if (diffPage.getDocumentVersion().get("docRevision")) {
                        this.t.d.diffVersion += "(" + diffPage.getDocumentVersion().get("docRevision") + ")";
                    }
                    if (this.diffMode === CompareConstants.diffMode.DIFFVERSION) {
                        this.t.d.diffClass = "active";
                    } else if (this.diffMode === CompareConstants.diffMode.CURRENTVERSION || this.diffMode === CompareConstants.diffMode.UNDEFINED) {
                        this.t.d.documentClass = "active";
                    }
                }
            }
            // render user
            this.t.d.user = this.f.getCurrentUser().getFullName();

            // render the template
            this.t.render();

            if (activePage.hasCad() || overlay) {
                var activeCad = overlay ? overlay : activePage;
                var activePageInfo = this.templateContext.find(".activeDocumentInfo");
                if (activePageInfo.length > 0) {
                    this._activePageInfoIcons.setDocumentPage(activeCad);
                    activePageInfo.append(this._activePageInfoIcons.getPageIcons());
                }
            }
            if (diffPage && diffPage.hasCad()) {
                var referencePageInfo = this.templateContext.find(".referenceDocumentInfo");
                if (referencePageInfo.length > 0) {
                    this._referencePageInfoIcons.setDocumentPage(diffPage);
                    referencePageInfo.append(this._referencePageInfoIcons.getPageIcons());
                }
            }
        };


        /**
         * @override
         * @returns {String}
         */
        DocumentInfoWidget.prototype.getWidgetType = function () {
            return "topbar";
        };

        /**
         * Change to first page
         */
        DocumentInfoWidget.prototype._firstPage = function () {
            var pageListModule = this.f.getModule("pagelist");
            if (pageListModule) {
                pageListModule.firstPage();
            } else {
                this.f.emit("error.SEVERE", "Pagelist module not loaded.");
            }
        };

        /**
         * Change to previous page
         */
        DocumentInfoWidget.prototype._previousPage = function () {
            var pageListModule = this.f.getModule("pagelist");
            if (pageListModule) {
                pageListModule.previousPage();
            } else {
                this.f.emit("error.SEVERE", "Pagelist module not loaded.");
            }
        };

        /**
         * Change to next page
         */
        DocumentInfoWidget.prototype._nextPage = function () {
            var pageListModule = this.f.getModule("pagelist");
            if (pageListModule) {
                pageListModule.nextPage();
            } else {
                this.f.emit("error.SEVERE", "Pagelist module not loaded.");
            }
        };

        /**
         * Change to last page
         */
        DocumentInfoWidget.prototype._lastPage = function () {
            var pageListModule = this.f.getModule("pagelist");
            if (pageListModule) {
                pageListModule.lastPage();
            } else {
                this.f.emit("error.SEVERE", "Pagelist module not loaded.");
            }
        };


        /**
         * Executed on click of the input page control
         * @param el
         * @param event
         */
        DocumentInfoWidget.prototype._currentPageClick = function (el, event) {
            if (!$(el).is(":focus")) {
                $(el).select();
                event.preventDefault();
            }
        };

        /**
         * Executed on enter of the input page control
         * @param el
         * @param event
         */
        DocumentInfoWidget.prototype._currentPageEnter = function (el, event) {
            if (event.which == 13 || event.keyCode == 13) {
                var value = $(el).val();
                var parsedValue = parseInt(value, 10);
                if (!isNaN(parsedValue)) {
                    // valid number
                    var activeDocumentVersion = this.f.getDocumentController().getActiveDocumentVersion();
                    // check boundaries
                    if (parsedValue < 1) {
                        parsedValue = 1;
                    } else if (parsedValue > activeDocumentVersion.getPageCount()) {
                        parsedValue = activeDocumentVersion.getPageCount();
                    }
                    // change page
                    var newPage = activeDocumentVersion.getPage(parsedValue);
                    if (newPage && newPage !== this.f.getDocumentController().getActivePage()) {
                        this.f.getDocumentController().changeActivePage(newPage);
                    } else {
                        if (!newPage) {
                            this.f.emit("userMessage", "warn", this.f.i18n.t("WarningGetNonexistentPage"), true);
                        }
                        // re-render to reset
                        this.render();
                    }
                } else {
                    // not valid number, re-render to reset
                    this.render();
                }
                event.preventDefault();
            }
        };

        /**
         * This method performs the reset of the layout (sends event to layout manager)
         * It first shows a popup to confirm.
         */
        DocumentInfoWidget.prototype._resetLayout = function () {
            if (!this._resetLayoutPopup) {
                this._resetLayoutPopup = new ModalPopup(this.f, "resetLayoutConfirm", this.f.getContext());
                this._resetLayoutPopup.setOkAction(_.bind(function () {
                    this.f.emit("layout.resetToDefault");
                    this._resetLayoutPopup.hide();
                }, this));
                // Header + Content
                this._resetLayoutPopup.setHeader($("<span/>").addClass("popupTitle").text(this.f.i18n.t("ResetLayout")));
                this._resetLayoutPopup.setContent($("<div/>").addClass("unsavedItemsContent").text(this.f.i18n.t("ResetLayoutConfirm")));
                this._resetLayoutPopup.setOkBtnText(this.f.i18n.t("YesResponse"));
                this._resetLayoutPopup.setCancelBtnText(this.f.i18n.t("NoResponse"));
            }
            this._resetLayoutPopup.show();
            this._resetLayoutPopup.recalculateSize(450);
        };

        DocumentInfoWidget.prototype._showJavaViewerIncompatiblePopup = function () {
            var modalPopup = new ModalPopup(this.f, "incompatibleJavaViewerDocument", this.f.getContext(), true);
            modalPopup.setRemoveFromDomAfterUsage(true);
            modalPopup.setOkAction(_.bind(function () {
                modalPopup.hide();
            }, this));
            // Header + Content
            modalPopup.setHeader($("<span/>").addClass("popupTitle").text(this.f.i18n.t("IncompatibleJavaViewerDocumentTitle")));
            modalPopup.setContent($("<div/>").addClass("unsavedItemsContent").text(this.f.i18n.t("IncompatibleJavaViewerDocumentMessage")));
            modalPopup.setOkBtnText(this.f.i18n.t("OkButton"));

            modalPopup.show();
        }

        return DocumentInfoWidget;
    });


define('tpl!web-viewer/documentInfo/InfoWidget', function(){return function(d){
var __t,__p='',__j=Array.prototype.join,print=function(){__p+=__j.call(arguments,'');};
__p+='<table>\r\n	';
 if(d.documentSize){ 
__p+='	\r\n		<tr>\r\n			<td class="infoWidgetSubtitle">'+
((__t=(d.i18n("InfoDocumentSize")))==null?'':_.escape(__t))+
' </td>\r\n			<td class="infoWidgetValue">'+
((__t=(d.documentSize.width ))==null?'':_.escape(__t))+
'&nbsp;x&nbsp;'+
((__t=(d.documentSize.height))==null?'':_.escape(__t))+
'&nbsp;'+
((__t=(d.i18n(d.sizeUnit)))==null?'':_.escape(__t))+
'</td>\r\n		</tr>\r\n		';
 if(!d.isCadOnly){ 
__p+='	\r\n			';
 if(d.documentSize.width !== d.trimboxSize.width || d.documentSize.height !== d.trimboxSize.height){ 
__p+='	\r\n			<tr>\r\n				<td class="infoWidgetSubtitle">'+
((__t=(d.i18n("InfoTrimSize")))==null?'':_.escape(__t))+
' </td>\r\n				<td class="infoWidgetValue">'+
((__t=(d.trimboxSize.width ))==null?'':_.escape(__t))+
'&nbsp;x&nbsp;'+
((__t=(d.trimboxSize.height))==null?'':_.escape(__t))+
'&nbsp;'+
((__t=(d.i18n(d.sizeUnit)))==null?'':_.escape(__t))+
'</td>\r\n			</tr>\r\n			';
 } 
__p+='	\r\n			';
 if(d.resolutionX && !isNaN(d.resolutionX) && d.resolutionY && !isNaN(d.resolutionY)){ 
__p+='	\r\n			<tr class="infoWidgetResolution">\r\n				<td class="infoWidgetSubtitle">'+
((__t=(d.i18n("InfoResolution")))==null?'':_.escape(__t))+
' </td>\r\n				';
 if(d.resolutionX !== d.resolutionY || d.resolutionXDiff !== d.resolutionYDiff){ 
__p+='	\r\n				<td class="infoWidgetValue">\r\n					X: '+
((__t=(d.resolutionX))==null?'':_.escape(__t))+
'\r\n					';
 if(d.resolutionXDiff && d.resolutionX !== d.resolutionXDiff){ 
__p+='	\r\n						&nbsp;/&nbsp;'+
((__t=(d.i18n(d.resolutionXDiff)))==null?'':_.escape(__t))+
'\r\n					';
 } 
__p+='\r\n					&nbsp;'+
((__t=(d.i18n(d.resolutionUnit)))==null?'':_.escape(__t))+
'\r\n					<br/>\r\n					Y: '+
((__t=(d.resolutionY))==null?'':_.escape(__t))+
'\r\n					';
 if(d.resolutionYDiff && d.resolutionY !== d.resolutionYDiff){ 
__p+='	\r\n						&nbsp;/&nbsp;'+
((__t=(d.i18n(d.resolutionYDiff)))==null?'':_.escape(__t))+
'\r\n					';
 } 
__p+='\r\n					&nbsp;'+
((__t=(d.i18n(d.resolutionUnit)))==null?'':_.escape(__t))+
'\r\n				</td>\r\n				';
 } else { 
__p+='	\r\n				<td class="infoWidgetValue">\r\n					'+
((__t=(d.resolutionX))==null?'':_.escape(__t))+
'\r\n					';
 if(d.resolutionXDiff && d.resolutionX !== d.resolutionXDiff){ 
__p+='	\r\n						&nbsp;/&nbsp;'+
((__t=(d.i18n(d.resolutionXDiff)))==null?'':_.escape(__t))+
'\r\n					';
 } 
__p+='\r\n					&nbsp;'+
((__t=(d.i18n(d.resolutionUnit)))==null?'':_.escape(__t))+
'\r\n				</td>\r\n				';
 } 
__p+='	\r\n			</tr>\r\n			';
 } 
__p+='	\r\n		';
 } 
__p+='	\r\n	';
 } 
__p+='	\r\n</table>\r\n\r\n<table class="infoWidgetBottomTable">\r\n	<tr>\r\n		<td class="infoWidgetBottom"><div class="infoWidgetIconPosition"></div></td>\r\n		<td rowspan="2" class="infoWidgetInnerBorder" />\r\n		<td class="infoWidgetBottom"><div class="infoWidgetIconSelection"></div></td>\r\n	</tr>\r\n	<tr>\r\n		<td class="infoWidgetBottom">\r\n			<div class="infoWidgetBottom">\r\n				<table>\r\n					<tr>\r\n						<td  class="infoWidgetBottomSubtitle">X:</td>\r\n						<td  class="infoWidgetValue">'+
((__t=(d.position?d.position.x:''))==null?'':_.escape(__t))+
'&nbsp;'+
((__t=(d.position?d.i18n(d.sizeUnit):'-'))==null?'':_.escape(__t))+
'</td>\r\n					</tr>\r\n					<tr>\r\n						<td  class="infoWidgetBottomSubtitle">Y:</td>\r\n						<td  class="infoWidgetValue">'+
((__t=(d.position?d.position.y:''))==null?'':_.escape(__t))+
'&nbsp;'+
((__t=(d.position?d.i18n(d.sizeUnit):'-'))==null?'':_.escape(__t))+
'</td>\r\n					</tr>\r\n				</table>\r\n			</div>\r\n		</td>\r\n		<td class="infoWidgetBottom">\r\n			<div class="infoWidgetBottom">\r\n				';
 if(d.selectionType === 0){ 
__p+='\r\n					<table>\r\n						<tr>\r\n							<td  class="infoWidgetBottomSubtitle">X:</td>\r\n							<td  class="infoWidgetValue">'+
((__t=(d.selection.x))==null?'':_.escape(__t))+
'&nbsp;'+
((__t=(d.i18n(d.sizeUnit)))==null?'':_.escape(__t))+
'</td>\r\n						</tr>\r\n						<tr>\r\n							<td  class="infoWidgetBottomSubtitle">Y:</td>\r\n							<td  class="infoWidgetValue">'+
((__t=(d.selection.y))==null?'':_.escape(__t))+
'&nbsp;'+
((__t=(d.i18n(d.sizeUnit)))==null?'':_.escape(__t))+
'</td>\r\n						</tr>\r\n						<tr>\r\n							<td  class="infoWidgetBottomSubtitle">'+
((__t=(d.i18n("InfoWidth")))==null?'':_.escape(__t))+
'</td>\r\n							<td  class="infoWidgetValue">'+
((__t=(d.selection.w))==null?'':_.escape(__t))+
'&nbsp;'+
((__t=(d.i18n(d.sizeUnit)))==null?'':_.escape(__t))+
'</td>\r\n						</tr>\r\n						<tr>\r\n							<td  class="infoWidgetBottomSubtitle">'+
((__t=(d.i18n("InfoHeight")))==null?'':_.escape(__t))+
'</td>\r\n							<td  class="infoWidgetValue">'+
((__t=(d.selection.h))==null?'':_.escape(__t))+
'&nbsp;'+
((__t=(d.i18n(d.sizeUnit)))==null?'':_.escape(__t))+
'</td>\r\n						</tr>\r\n					</table>\r\n				';
 } else if(d.selectionType === 1){ 
__p+='	\r\n					<table>\r\n						<tr>\r\n							<td  class="infoWidgetBottomSubtitle">'+
((__t=(d.i18n("InfoDist")))==null?'':_.escape(__t))+
'</td>\r\n							<td  class="infoWidgetValue">'+
((__t=(d.selection.d))==null?'':_.escape(__t))+
'&nbsp;'+
((__t=(d.i18n(d.sizeUnit)))==null?'':_.escape(__t))+
'</td>\r\n						</tr>\r\n						<tr>\r\n							<td  class="infoWidgetBottomSubtitle">'+
((__t=(d.i18n("InfoAngle")))==null?'':_.escape(__t))+
'</td>\r\n							<td  class="infoWidgetValue">'+
((__t=(d.selection.a))==null?'':_.escape(__t))+
'&#176;</td>\r\n						</tr>\r\n						<tr>\r\n							<td  class="infoWidgetBottomSubtitle">'+
((__t=(d.i18n("InfoWidth")))==null?'':_.escape(__t))+
'</td>\r\n							<td  class="infoWidgetValue">'+
((__t=(d.selection.w))==null?'':_.escape(__t))+
'&nbsp;'+
((__t=(d.i18n(d.sizeUnit)))==null?'':_.escape(__t))+
'</td>\r\n						</tr>\r\n						<tr>\r\n							<td  class="infoWidgetBottomSubtitle">'+
((__t=(d.i18n("InfoHeight")))==null?'':_.escape(__t))+
'</td>\r\n							<td  class="infoWidgetValue">'+
((__t=(d.selection.h))==null?'':_.escape(__t))+
'&nbsp;'+
((__t=(d.i18n(d.sizeUnit)))==null?'':_.escape(__t))+
'</td>\r\n						</tr>\r\n					</table>\r\n				';
 } else if(d.selectionType === 2){ 
__p+='	\r\n					<table>\r\n						<tr>\r\n							<td  class="infoWidgetBottomSubtitle">X:</td>\r\n							<td  class="infoWidgetValue">'+
((__t=(d.selection.x))==null?'':_.escape(__t))+
'&nbsp;'+
((__t=(d.i18n(d.sizeUnit)))==null?'':_.escape(__t))+
'</td>\r\n						</tr>\r\n						<tr>\r\n							<td  class="infoWidgetBottomSubtitle">'+
((__t=(d.i18n("InfoWidth")))==null?'':_.escape(__t))+
'</td>\r\n							<td  class="infoWidgetValue">'+
((__t=(d.selection.w))==null?'':_.escape(__t))+
'&nbsp;'+
((__t=(d.i18n(d.sizeUnit)))==null?'':_.escape(__t))+
'</td>\r\n						</tr>\r\n					</table>\r\n				';
 } else if(d.selectionType === 3){ 
__p+='	\r\n					<table>\r\n						<tr>\r\n							<td  class="infoWidgetBottomSubtitle">Y:</td>\r\n							<td  class="infoWidgetValue">'+
((__t=(d.selection.y))==null?'':_.escape(__t))+
'&nbsp;'+
((__t=(d.i18n(d.sizeUnit)))==null?'':_.escape(__t))+
'</td>\r\n						</tr>\r\n						<tr>\r\n							<td  class="infoWidgetBottomSubtitle">'+
((__t=(d.i18n("InfoHeight")))==null?'':_.escape(__t))+
'</td>\r\n							<td  class="infoWidgetValue">'+
((__t=(d.selection.h))==null?'':_.escape(__t))+
'&nbsp;'+
((__t=(d.i18n(d.sizeUnit)))==null?'':_.escape(__t))+
'</td>\r\n						</tr>\r\n					</table>\r\n				';
 } 
__p+='	\r\n			</div>\r\n		</td>\r\n	</tr>\r\n</table>';
return __p;
}});
define('web-viewer/documentInfo/InfoWidget',["web-viewer/layout/AbstractWidget",
		"Template",
		"web-viewer/layout/LayoutConstants",
		"tpl!web-viewer/documentInfo/InfoWidget",
		"web-viewer/core/CoreConstants",
		"web-viewer/compare/CompareConstants",
		"web-viewer/utils/ListenerUtil",
		"web-viewer/utils/ViewerUtils",
		"utils/ShapeUtils",
		"web-viewer/utils/Coordinates",
		"web-viewer/layout/component/DropdownMiniButton",
		"component/tooltip/Tooltip",
		"underscore"
	],
	function (AbstractWidget,
		Template,
		LayoutConstants,
		tpl,
		CoreConstants,
		CompareConstants,
		ListenerUtil,
		ViewerUtils,
		ShapeUtils,
		Coordinates,
		DropdownMiniButton,
		Tooltip,
		_) {
		"use strict";

		/**
		 * @exports InfoWidget
		 * @augments Layout.AbstractWidget
		 * @class The InfoWidget shows some information on the document and the viewport
		 * @constructor
		 * @mixes {Utils.ListenerUtilMixin}
		 * @param {Core.ViewerFacade} f
		 *  @param {DocumentInfo.DocumentInfoModel} documentInfoModel
		 */
		var InfoWidget = function InfoWidget(f, documentInfoModel) {
			AbstractWidget.call(this, f, LayoutConstants.Widget.INFO);
			ListenerUtil.mixin(this, f);

			this._model = documentInfoModel;

			
			// initialize template
			this.t = new Template(f.i18n, tpl);

			/**
			 * {Layout.Component.Tooltip} tooltip for resolution
			 */
			this.tooltip = null;

			// default settings
			/**
			 * {CoreConstants.SizeUnits}
			 */
			this._sizeUnit = this.f.getOption("PREFERENCES_UNIT_SIZE");

			/**
			 * {CoreConstants.ResolutionUnits}
			 */
			this._resUnit = this.f.getOption("PREFERENCES_UNIT_RESOLUTION");

			/**
			 * {boolean}
			 */
			this._showDiffPage = false;

			/**
			 * {MeasureConstants.MeasureDrawType}
			 */
			this.t.d.selectionType = null;

			/**
			 * {MeasureConstants.MeasureDrawType}
			 */
			this._previousSelectionType = null;

			/**
			 * {Coordinates} - util for coordinate conversion
			 */
			this._coordinates = new Coordinates(this.f);

			/**
			 * Make the options dropdown
			 */
			this._optionButton = new DropdownMiniButton(f, "infoUnitSettings", "icon-WCR_Settings-submenu");

			this.setIcon("icon icon-WCR_Info");
			
			f.i18n.loadBundle("viewer", function () {
				this.setTitle(this.f.i18n.t("InfoWidgetTitle"));

				// Units for size
				function toggleSizeUnit(mode, toggle) {
					if (toggle) {
						this.setSizeUnit(mode);
					}
				}

				this._optionButton.addOption({
					name: 'sizeUnitPixels',
					content: this.f.i18n.t(this.f.getUnitsLocName(CoreConstants.SizeUnits.PIXELS)),
					onchange: _.bind(toggleSizeUnit, this, CoreConstants.SizeUnits.PIXELS),
					selected: this._sizeUnit === CoreConstants.SizeUnits.PIXELS,
					userCannotUncheck: true
				});

				this._optionButton.addOption({
					name: 'sizeUnitMm',
					content: this.f.i18n.t(this.f.getUnitsLocName(CoreConstants.SizeUnits.MM)),
					onchange: _.bind(toggleSizeUnit, this, CoreConstants.SizeUnits.MM),
					selected: this._sizeUnit === CoreConstants.SizeUnits.MM,
					userCannotUncheck: true
				});

				this._optionButton.addOption({
					name: 'sizeUnitCm',
					content: this.f.i18n.t(this.f.getUnitsLocName(CoreConstants.SizeUnits.CM)),
					onchange: _.bind(toggleSizeUnit, this, CoreConstants.SizeUnits.CM),
					selected: this._sizeUnit === CoreConstants.SizeUnits.CM,
					userCannotUncheck: true
				});

				this._optionButton.addOption({
					name: 'sizeUnitInch',
					content: this.f.i18n.t(this.f.getUnitsLocName(CoreConstants.SizeUnits.INCH)),
					onchange: _.bind(toggleSizeUnit, this, CoreConstants.SizeUnits.INCH),
					selected: this._sizeUnit === CoreConstants.SizeUnits.INCH,
					userCannotUncheck: true
				});

				this._optionButton.addDivider();


				// units for resolution
				function toggleResolutionUnit(mode, toggle) {
					if (toggle) {
						this.setResolutionUnit(mode);
					}
				}

				this._optionButton.addOption({
					name: 'resUnitPpmm',
					content: this.f.i18n.t("UnitResmm"),
					onchange: _.bind(toggleResolutionUnit, this, CoreConstants.ResolutionUnits.PPMM),
					selected: this._resUnit === CoreConstants.ResolutionUnits.PPMM,
					userCannotUncheck: true
				});

				this._optionButton.addOption({
					name: 'resUnitPpcm',
					content: this.f.i18n.t("UnitRescm"),
					onchange: _.bind(toggleResolutionUnit, this, CoreConstants.ResolutionUnits.PPCM),
					selected: this._resUnit === CoreConstants.ResolutionUnits.PPCM,
					userCannotUncheck: true
				});

				this._optionButton.addOption({
					name: 'resUnitPpi',
					content: this.f.i18n.t("UnitResInch"),
					onchange: _.bind(toggleResolutionUnit, this, CoreConstants.ResolutionUnits.PPI),
					selected: this._resUnit === CoreConstants.ResolutionUnits.PPI,
					userCannotUncheck: true
				});

				this._optionButton.setTooltip("viewer", "UnitSettings");

				this.whenContextAvailable(_.bind(function () {
					this.f.getDocumentController().whenActiveOrDifferencePageChangedAndParametersAvailableOrChange(function () {
						// if we have a CAD file, we need to show points instead of pixels and we don't shown resolution. 
						// Note that viewerfacade handles the units, we just need to refresh when this changed
						var hasCad = this._getInfoPage() && this._getInfoPage().hasCad();
						if (hasCad) {
							this.f.requestModule("cad", _.bind(function () {
								this._getInfoPage().requestCad(_.bind(this.render, this));
							}, this), true);
						}

						var isCadOnly = hasCad && !this._getInfoPage().hasGraphics();
						this.t.d.isCadOnly = isCadOnly;
						this._optionButton.setActionText("sizeUnitPixels", this.f.i18n.t(this.f.getUnitsLocName(CoreConstants.SizeUnits.PIXELS)));
						this._optionButton.toggleOption("sizeUnitPixels", this._sizeUnit === CoreConstants.SizeUnits.PIXELS); // recover icon if selected

						this.render();
					}, this);

					// listen to diffMode, so we can show the info of the correct document (active or difference)
					this._registerListener("module.compare.changed.diffMode", function (oldMode, newMode) {
						this._showDiffPage = (newMode === CompareConstants.diffMode.DIFFVERSION);
						this.render();
					}, this);

					// rerender when unit settings change
					this.f.getCurrentUser().on("options.changed.PREFERENCES_UNIT_SIZE", _.bind(function (oldValue, newValue) {
						this.setSizeUnit(newValue);
					}, this));
					this.f.getCurrentUser().on("options.changed.PREFERENCES_UNIT_RESOLUTION", _.bind(function (oldValue, newValue) {
						this.setResolutionUnit(newValue);
					}, this));

					// rerender when mouselocation changes
					this._model.on("changed.mouselocation", _.bind(function () {
						this.updateMouseLocation();
					}, this));

					// rerender when mouselocation changes
					this._model.on("changed.selection", _.bind(function () {
						this.updateSelection();
					}, this));
				}, this));
			}, this);
		};

		InfoWidget.prototype = Object.create(AbstractWidget.prototype);
		InfoWidget.prototype.constructor = InfoWidget;
		InfoWidget.widgetName = LayoutConstants.Widget.INFO;



		/**
		 * @override
		 */
		InfoWidget.prototype.setContext = function (context, headerExtra) {
			AbstractWidget.prototype.setContext.call(this, context, headerExtra);

			this.context.addClass("enableTextSelection infoWidget");
			this.t.setContext(this.context);

			// add buttons to the widget header
			this.headerExtra.append(this._optionButton.element);

			this.render();
		};

		/**
		 * Render the widget.
		 * When information cannot be shown, make sure the template does not show it by removing the data.
		 */
		InfoWidget.prototype.render = function () {
			// get size and resolution data
			var sizeUnit = this.f.getUnits();
			var sizeUnitLoc = this.f.getUnitsLocName();
			var sizeUnitFix = this.f.getUnitsFix();

			var resUnit = this.f.getResolutionUnits();
			var resUnitLoc = this.f.getResolutionUnitsLocName();
			var resUnitFix = this.f.getResolutionUnitsFix();

			// for calculations, use resolution of current page (can be active or diff)
			var currentPage = this._getInfoPage();
			var resX = ViewerUtils.parseFloat(currentPage.getParam("resolutionx"));
			var resY = ViewerUtils.parseFloat(currentPage.getParam("resolutiony"));

			var documentSize = currentPage.getPageSize();
			var margin = currentPage.getMargins();

			if (documentSize) {
				// convert size and resolution to correct units and put in template data
				this.t.d.documentSize = new ShapeUtils.Size(ViewerUtils.convertFromMmValue(documentSize.width, sizeUnit, sizeUnitFix, resX),
					ViewerUtils.convertFromMmValue(documentSize.height, sizeUnit, sizeUnitFix, resY));
				var trimbox = new ShapeUtils.Rect(new ShapeUtils.Point(margin.left, margin.top), new ShapeUtils.Size(documentSize.width - margin.left - margin.right, documentSize.height - margin.top - margin.bottom));
				var trimboxSize = trimbox.size;
				this.t.d.trimboxSize = new ShapeUtils.Size(ViewerUtils.convertFromMmValue(trimboxSize.width, sizeUnit, sizeUnitFix, resX),
					ViewerUtils.convertFromMmValue(trimboxSize.height, sizeUnit, sizeUnitFix, resY));

				// for display, show both active and difference page
				var activePage = this.f.getActivePage();
				var resXActive = ViewerUtils.parseFloat(activePage.getParam("resolutionx"));
				var resYActive = ViewerUtils.parseFloat(activePage.getParam("resolutiony"));
				this.t.d.resolutionX = ViewerUtils.convertResolutionFromPpmmValue(resXActive, resUnit, resUnitFix);
				this.t.d.resolutionY = ViewerUtils.convertResolutionFromPpmmValue(resYActive, resUnit, resUnitFix);
				this.t.d.resolutionUnit = resUnitLoc;

				var diffPage = this.f.getDocumentController().getDifferencePage();
				if (diffPage) {
					var resXDiff = ViewerUtils.parseFloat(diffPage.getParam("resolutionx"));
					var resYDiff = ViewerUtils.parseFloat(diffPage.getParam("resolutiony"));
					if (resXDiff && resYDiff) {
						this.t.d.resolutionXDiff = ViewerUtils.convertResolutionFromPpmmValue(resXDiff, resUnit, resUnitFix);
						this.t.d.resolutionYDiff = ViewerUtils.convertResolutionFromPpmmValue(resYDiff, resUnit, resUnitFix);
					}
				} else {
					//the world size (from parameters) needs to be the same as the document size (since there is no reference document page)
					var worldDocumentSize = new ShapeUtils.Size(ViewerUtils.parseFloat(currentPage.getParam("sizex")), ViewerUtils.parseFloat(currentPage.getParam("sizey")));
					if (!currentPage.hasCad() && (!ViewerUtils.isCloseTo(worldDocumentSize.width, documentSize.width, 1) || !ViewerUtils.isCloseTo(worldDocumentSize.height, documentSize.height, 1))) {
						this.t.d.documentSize = new ShapeUtils.Size(ViewerUtils.convertFromMmValue(worldDocumentSize.width, sizeUnit, sizeUnitFix, resX), ViewerUtils.convertFromMmValue(worldDocumentSize.height, sizeUnit, sizeUnitFix, resY));
					}
					this.t.d.resolutionXDiff = null;
					this.t.d.resolutionYDiff = null;
				}
			} else {
				// nothing can be shown
				this.t.d.documentSize = null;
				this.t.d.trimboxSize = null;

			}
			// set units localized
			this.t.d.sizeUnit = sizeUnitLoc;

			this.updateMouseLocation(true);
			this.updateSelection(true);

			this._renderWidget();
		};

		/**
		 * Update the mouse location and rerender the template.
		 * Mouse point is converted to selected units.
		 * @param {boolean} skipRender - don't render (render is done outside the function)
		 */
		InfoWidget.prototype.updateMouseLocation = function (skipRender) {
			var mousePos = this._model.getMousePosition();
			if (mousePos) {
				var activePage = this._getInfoPage();
				var resX = ViewerUtils.parseFloat(activePage.getParam("resolutionx"));
				var resY = ViewerUtils.parseFloat(activePage.getParam("resolutiony"));

				//convert to correct coordinate system
				var mousePoint = this._coordinates.getTransformedPoint(new ShapeUtils.Point(mousePos.x, mousePos.y));

				// convert and pass infor to template
				this.t.d.position = {
					x: ViewerUtils.convertFromMmValue(mousePoint.x, this.f.getUnits(), this.f.getUnitsFix(), resX),
					y: ViewerUtils.convertFromMmValue(mousePoint.y, this.f.getUnits(), this.f.getUnitsFix(), resY)
				};
			} else {
				// mouse is not in viewport, don't show coordinates
				this.t.d.position = null;
			}

			if (!skipRender) {
				this._renderWidget();
			}
		};

		/**
		 * Update the selection and rerender the template
		 * Selection is converted to selected units
		 * @param {boolean} skipRender - don't render (render is done outside the function)
		 */
		InfoWidget.prototype.updateSelection = function (skipRender) {
			var selection = this._model.getSelection();
			var fireResized = false;
			if (selection === null) {
				// nothing can be shown
				this.t.d.selectionType = null;
				fireResized = (this._previousSelectionType !== null);
				this._previousSelectionType = null;

			} else {
				fireResized = (this._previousSelectionType !== selection.mode);
				this._previousSelectionType = selection.mode;
				this.t.d.selectionType = selection.mode;
				this.t.d.selection = {};

				// handle offsets and convert values
				var activePage = this._getInfoPage();
				var resX = ViewerUtils.parseFloat(activePage.getParam("resolutionx"));
				var resY = ViewerUtils.parseFloat(activePage.getParam("resolutiony"));
				var offsetX = ViewerUtils.parseFloat(activePage.get("offsetx"));
				if (isNaN(offsetX)) {
					offsetX = 0;
				}
				var offsetY = ViewerUtils.parseFloat(activePage.get("offsety"));
				if (isNaN(offsetY)) {
					offsetY = 0;
				}

				//convert to correct coordinate system
				var selectionPoint = this._coordinates.getTransformedPoint(new ShapeUtils.Point(selection.x, selection.y));

				// convert to selected units
				this.t.d.selection.x = (selectionPoint !== undefined) ? ViewerUtils.convertFromMmValue(selectionPoint.x, this.f.getUnits(), this.f.getUnitsFix(), resX) : null;
				this.t.d.selection.y = (selectionPoint !== undefined) ? ViewerUtils.convertFromMmValue(selectionPoint.y, this.f.getUnits(), this.f.getUnitsFix(), resY) : null;
				this.t.d.selection.w = (selection.w !== undefined) ? ViewerUtils.convertFromMmValue(selection.w, this.f.getUnits(), this.f.getUnitsFix(), resX) : null;
				this.t.d.selection.h = (selection.h !== undefined) ? ViewerUtils.convertFromMmValue(selection.h, this.f.getUnits(), this.f.getUnitsFix(), resY) : null;
				if (selection.d !== undefined && selection.a !== undefined) {
					// use combined resolution for diagonal
					var angleRad = selection.a * Math.PI / 180;
					var combinedRes = Math.sqrt(Math.cos(angleRad) * Math.cos(angleRad) * resX * resX + Math.sin(angleRad) * Math.sin(angleRad) * resY * resY);
					this.t.d.selection.d = (selection.d !== undefined) ? ViewerUtils.convertFromMmValue(selection.d, this.f.getUnits(), this.f.getUnitsFix(), combinedRes) : null;
					if (selection.a !== undefined) {
						this.t.d.selection.a = this.f.getOption("PREFERENCES_RULER_ANGLE_MODE") ? -selection.a.toFixed(2) : selection.a.toFixed(2);
					} else {
						this.t.d.selection.a = null;
					}
				}
			}

			if (!skipRender) {
				this._renderWidget();

				// resize widget if needed
				if (fireResized) {
					this._fireResized();
				}
			}
		};

		/**
		 * Set the unit for size. This does not persist.
		 * @param {CoreConstants.SizeUnits} mode
		 */
		InfoWidget.prototype.setSizeUnit = function (mode) {
			if (this._sizeUnit !== mode) {
				this._sizeUnit = mode;

				// update toggles
				this._optionButton.toggleOption("sizeUnitPixels", mode === CoreConstants.SizeUnits.PIXELS);
				this._optionButton.toggleOption("sizeUnitMm", mode === CoreConstants.SizeUnits.MM);
				this._optionButton.toggleOption("sizeUnitCm", mode === CoreConstants.SizeUnits.CM);
				this._optionButton.toggleOption("sizeUnitInch", mode === CoreConstants.SizeUnits.INCH);

				this.f.setOption("PREFERENCES_UNIT_SIZE", mode, true);

				this.render();
			}
		};

		/**
		 * Set the unit for resolution. This does not persist.
		 * @param {CoreConstants.ResolutionUnits} mode
		 */
		InfoWidget.prototype.setResolutionUnit = function (mode) {
			if (this._resUnit !== mode) {
				this._resUnit = mode;

				// update toggles
				this._optionButton.toggleOption("resUnitPpmm", mode === CoreConstants.ResolutionUnits.PPMM);
				this._optionButton.toggleOption("resUnitPpcm", mode === CoreConstants.ResolutionUnits.PPCM);
				this._optionButton.toggleOption("resUnitPpi", mode === CoreConstants.ResolutionUnits.PPI);

				this.f.setOption("PREFERENCES_UNIT_RESOLUTION", mode, true);

				this.render();
			}
		};

		/**
		 * Get the page which we should shown information of (active or difference)
		 * @param {boolean} getOther - get the page that is not shown instead of the one that's shown
		 * @returns {AbstractDocumentPage} active or difference page
		 */
		InfoWidget.prototype._getInfoPage = function (getOther) {
			var getDiff = this._showDiffPage;
			if (getOther) {
				getDiff = !getDiff;
			}

			if (getDiff) {
				return this.f.getDocumentController().getDifferencePage();
			} else {
				return this.f.getActivePage();
			}
		};

		/**
		 * Render Widget and create tooltip
		 */
		InfoWidget.prototype._renderWidget = function (getOther) {
			this.t.render();

			// enable tooltip
			if ((this.t.d.resolutionX && this.t.d.resolutionXDiff && this.t.d.resolutionX !== this.t.d.resolutionXDiff) || (this.t.d.resolutionY && this.t.d.resolutionYDiff && this.t.d.resolutionY !== this.t.d.resolutionYDiff)) {
				if (this.tooltip) {
					this.tooltip.setContext(this.context.find(".infoWidgetResolution"));
					this.tooltip.enableTooltip();
				} else {
					this.tooltip = new Tooltip(this.f.i18n, this.context.find(".infoWidgetResolution"), this.f.getContext(), this.f.getContext(), this.f.isMobile(),this.f.i18n.t("InfoWidgetResCurrentRefTT"));
				}
			}
		};

		return InfoWidget;
	});


define('tpl!web-viewer/documentInfo/DebugWidget', function(){return function(d){
var __t,__p='',__j=Array.prototype.join,print=function(){__p+=__j.call(arguments,'');};
__p+='<table>\r\n	<tr>\r\n		<th colspan="2">Document</th>\r\n	</tr>\r\n	<tr>\r\n		<td>Size: </td>\r\n		<td>'+
((__t=(d.documentSize.width.toFixed(3) ))==null?'':_.escape(__t))+
'*'+
((__t=(d.documentSize.height.toFixed(3)))==null?'':_.escape(__t))+
' mm</td>\r\n	</tr>\r\n	<tr>\r\n		<td>Resolution: </td>\r\n		<td>'+
((__t=((+d.resolution).toFixed(3)))==null?'':_.escape(__t))+
' ppmm</td>\r\n	</tr>\r\n	<tr>\r\n		<th colspan="2">Viewport</th>\r\n	</tr>\r\n	<tr>\r\n		<td>World size: </td>\r\n		<td>'+
((__t=(d.world.getWorldSize().width.toFixed(3) ))==null?'':_.escape(__t))+
'*'+
((__t=(d.world.getWorldSize().height.toFixed(3)))==null?'':_.escape(__t))+
' mm</td>\r\n	</tr>\r\n	<tr>\r\n		<td>Scene size: </td>\r\n		<td>'+
((__t=(d.world.getSceneSize().width ))==null?'':_.escape(__t))+
'*'+
((__t=(d.world.getSceneSize().height))==null?'':_.escape(__t))+
' px</td>\r\n	</tr>\r\n	<tr>\r\n		<td>Document position: </td>\r\n		<td>('+
((__t=(d.targetViewport.origin.x.toFixed(2)))==null?'':_.escape(__t))+
','+
((__t=(d.targetViewport.origin.y.toFixed(2)))==null?'':_.escape(__t))+
')-('+
((__t=(d.targetViewport.size.width.toFixed(2)))==null?'':_.escape(__t))+
'*'+
((__t=(d.targetViewport.size.height.toFixed(2)))==null?'':_.escape(__t))+
')</td>\r\n	</tr> \r\n	<tr>\r\n		<td>Canvas position: </td>\r\n		<td>('+
((__t=((d.targetViewport.origin.x*d.world.getZoom()).toFixed(2)))==null?'':_.escape(__t))+
','+
((__t=((d.targetViewport.origin.y*d.world.getZoom()).toFixed(2)))==null?'':_.escape(__t))+
')-('+
((__t=((d.targetViewport.size.width*d.world.getZoom()).toFixed(2)))==null?'':_.escape(__t))+
'*'+
((__t=((d.targetViewport.size.height*d.world.getZoom()).toFixed(2)))==null?'':_.escape(__t))+
')</td>\r\n	</tr> 	\r\n	<tr>\r\n		<td>Offset size: </td>\r\n		<td>'+
((__t=((d.world.getOffsetSize().width).toFixed(2)))==null?'':_.escape(__t))+
' * '+
((__t=((d.world.getOffsetSize().height).toFixed(2)))==null?'':_.escape(__t))+
'</td>\r\n	</tr> 	\r\n	<tr>\r\n		<td>Offset size: </td>\r\n		<td>'+
((__t=((d.world.getOffsetSize().width*d.world.getZoom()).toFixed(2)))==null?'':_.escape(__t))+
' * '+
((__t=((d.world.getOffsetSize().height*d.world.getZoom()).toFixed(2)))==null?'':_.escape(__t))+
'</td>\r\n	</tr>\r\n	<tr>\r\n		<td>World middle</td>\r\n		<td>'+
((__t=(d.world.getMiddle().x.toFixed(2)))==null?'':_.escape(__t))+
', '+
((__t=(d.world.getMiddle().y.toFixed(2)))==null?'':_.escape(__t))+
'</td>\r\n	</tr>\r\n	<tr>\r\n		<td>World zoom<br/>resolution</td>\r\n		<td>'+
((__t=(d.world.getZoom().toFixed(3)))==null?'':_.escape(__t))+
' ppmm</td>\r\n	</tr>\r\n	<tr>\r\n		<td>World resolution</td>\r\n		<td>x: '+
((__t=(d.world.getWorldResolution().x))==null?'':_.escape(__t))+
', y: '+
((__t=(d.world.getWorldResolution().y))==null?'':_.escape(__t))+
'</td>\r\n	</tr>\r\n	<tr> \r\n		<td>Zoom</td>\r\n		<td>'+
((__t=(d.getZoom()))==null?'':_.escape(__t))+
'</td>\r\n	</tr>\r\n	<tr> \r\n		<td>initialZoom</td>\r\n		<td>'+
((__t=(d.world.getInitialZoom()))==null?'':_.escape(__t))+
'</td>\r\n	</tr>\r\n	<tr> \r\n		<td>initialStartZoom</td>\r\n		<td>'+
((__t=(d.world.getInitialStartZoom()))==null?'':_.escape(__t))+
'</td>\r\n	</tr>\r\n	<tr> \r\n		<td>Rotation</td>\r\n		<td>'+
((__t=(d.world.getRotation()))==null?'':_.escape(__t))+
'</td>\r\n	</tr>\r\n	';
 if (d.world.isDeepZoom()){ 
__p+='\r\n		<tr>\r\n			<th colspan="2">DEEPZOOM</th>\r\n		</tr>\r\n	';
 }
__p+='\r\n	<tr>\r\n		<th colspan="2">Transform (world coordinates)</th>\r\n	</tr>\r\n	<tr> \r\n		<td colspan="2">\r\n			<table>\r\n				<tr>\r\n					<td>'+
((__t=(d.world.getTransformation().a.toFixed(2)))==null?'':_.escape(__t))+
'</td>\r\n					<td>'+
((__t=(d.world.getTransformation().c.toFixed(2)))==null?'':_.escape(__t))+
'</td>\r\n					<td>'+
((__t=(d.world.getTransformation().e.toFixed(2)))==null?'':_.escape(__t))+
'</td>\r\n				</tr>\r\n				<tr>\r\n					<td>'+
((__t=(d.world.getTransformation().b.toFixed(2)))==null?'':_.escape(__t))+
'</td>\r\n					<td>'+
((__t=(d.world.getTransformation().d.toFixed(2)))==null?'':_.escape(__t))+
'</td>\r\n					<td>'+
((__t=(d.world.getTransformation().f.toFixed(2)))==null?'':_.escape(__t))+
'</td>\r\n				</tr>\r\n			</table>\r\n		</td>\r\n	</tr>\r\n</table>';
return __p;
}});
define('web-viewer/documentInfo/DebugWidget',["web-viewer/layout/AbstractWidget",
		"Template",
		"web-viewer/layout/LayoutConstants",
		"tpl!web-viewer/documentInfo/DebugWidget",
		"web-viewer/utils/ListenerUtil",
		"jquery",
		"underscore"
	],
	function (AbstractWidget,
		Template,
		LayoutConstants,
		tpl,
		ListenerUtil,
		$,
		_) {

		/**
		 * @exports DebugWidget
		 * @augments Layout.AbstractWidget
		 * @class The DebugWidget shows some debug information on the viewport
		 * @constructor
		 * @mixes {Utils.ListenerUtilMixin}
		 * @param {Core.ViewerFacade} f
		 */
		var DebugWidget = function DebugWidget(f) {
			AbstractWidget.call(this, f, LayoutConstants.Widget.DEBUG);
			ListenerUtil.mixin(this, f);

			this.setTitle("Debug Info");

			// initialize template
			this.t = new Template(f.i18n, tpl);


			var viewportModule = this.f.getModule("viewport");
			this.t.d.world = viewportModule.world;
			this.t.d.getZoom = _.bind(function () {
				var activePage = this.f.getActivePage();
				var docRes = activePage.getParam("resolutionx");
				var sceneRes = viewportModule.world.getZoom();

				if (docRes > sceneRes) {
					// zoomed out
					return (docRes / sceneRes).toFixed(3) + " : 1";
				} else {
					// zoomed in
					return "1 : " + (sceneRes / docRes).toFixed(3);
				}
			}, this);
			this._registerListener("transform.**", this.render, this);
			this.f.getDocumentController().whenActiveOrDifferencePageChangedAndParametersAvailable(this.render, this);
		};

		DebugWidget.prototype = Object.create(AbstractWidget.prototype);
		DebugWidget.prototype.constructor = DebugWidget;
		DebugWidget.widgetName = LayoutConstants.Widget.DEBUG;


		/**
		 * @override
		 */
		DebugWidget.prototype.setContext = function (context) {
			AbstractWidget.prototype.setContext.call(this, context);

			this.context.addClass("enableTextSelection");
			this.t.setContext(this.context);
			this.render();
		};

		/**
		 * Render the widget
		 */
		DebugWidget.prototype.render = function () {
			var activePage = this.f.getActivePage();
			this.t.d.documentSize = activePage.getPageSize();
			this.t.d.resolution = activePage.getParam("resolutionx");
			this.t.d.targetViewport = this.t.d.world.getTargetViewPort();
			this.t.render();
		};
		return DebugWidget;
	});

define('web-viewer/documentInfo/DocumentInfoModel',["underscore",
		"web-viewer/core/AbstractModel"
	],
	function (_,
		AbstractModel) {
		"use strict";
		/**
		 * @exports DocumentInfoModel
		 * @memberof DocumentInfoModule
		 * @augments AbstractModel
		 * @class This class gives the needed info for the info widget
		 * @constructor
		 *
		 * @param {Core.ViewerFacade} f - Viewer facade
		 * @param {String} ID - the ID of the model
		 */
		var DocumentInfoModel = function (f, ID) {
			AbstractModel.call(this, f, ID);

			/**
			 * {ShapeUtils.Point}
			 * previous position of the mouse
			 */
			this._previousMousePosition = null;

			/**
			 * {ShapeUtils.Point}
			 * current position of the mouse
			 */
			this._mousePosition = null;

			/**
			 * {ShapeUtils.Point}
			 * current selection
			 */
			this._selection = null;

			/**
			 * {ShapeUtils.Point}
			 * previous selection
			 */
			this._previousSelection = null;
		};
		// inherit
		DocumentInfoModel.prototype = Object.create(AbstractModel.prototype);
		DocumentInfoModel.prototype.constructor = DocumentInfoModel;

		/**
		 * Set the position of the mouse in the model
		 * @param {ShapeUtils.Point} mousePoint - mouse position
		 */
		DocumentInfoModel.prototype.setMousePosition = function (mousePoint) {
			this._mousePosition = mousePoint;
			this._throttledFireChangeForPosition();
		};

		/**
		 * Sends out an event that mouse position has changed. This is based on the state, so it can be throttled.
		 */
		DocumentInfoModel.prototype._throttledFireChangeForPosition = _.throttle(function () {
			this._fireChange(false, ["mouselocation"], this._previousMousePosition, this._mousePosition);
			this._previousMousePosition = this._mousePosition;
		}, 50);

		/**
		 * Get mouse position.
		 * @returns {ShapeUtils.Point} - position of the mouse
		 */
		DocumentInfoModel.prototype.getMousePosition = function () {
			return this._mousePosition;
		};

		/**
		 * Sends out an event that selection has changed. This is based on the state, so it can be throttled.
		 */
		DocumentInfoModel.prototype._throttledFireChangeForSelection = _.throttle(function () {
			this._fireChange(false, ["selection"], this._previousSelection, this._selection);
			this._previousSelection = this._selection;
		}, 50);

		/**
		 * Set the selection in the model
		 * @param {Object} selection - new selection
		 * Selection Object can contain following information
		 * 		{
		 * 			a: angle in degrees
		 * 			d: distance in mm
		 * 			x: x coordinate in mm
		 * 			y: y coordinate in mm
		 * 			w: width in mm
		 * 			h: height in mm
		 * 		}
		 */
		DocumentInfoModel.prototype.setSelection = function (selection) {
			this._selection = selection;
			this._throttledFireChangeForSelection();
		};

		/**
		 * Get mouse position.
		 * @returns {ShapeUtils.Point} - position of the mouse.
		 */
		DocumentInfoModel.prototype.getSelection = function () {
			return this._selection;
		};

		return DocumentInfoModel;
	});

define('web-viewer/documentInfo/MouseLocatorTool',["underscore",
		"web-viewer/viewport/tools/AbstractTool",
		"web-viewer/core/CoreConstants"
	],
	function (_,
		AbstractTool,
		CoreConstants) {
		"use strict";

		/**
		 * @exports MouseLocatorTool
		 * @memberof DocumentInfoModule
		 * @augments Viewport.AbstractTool
		 *
		 * @class
		 * The MouseLocatorTool will send out events for the mouse position within the viewport
		 *
		 * @constructor
		 * @param {Core.ViewerFacade} f
		 * @param {DocumentInfo.DocumentInfoModel} documentInfoModel
		 */
		var MouseLocatorTool = function MouseLocator(f, documentInfoModel) {
			AbstractTool.call(this, f, CoreConstants.TOOLS.MOUSE_LOCATOR);

			/**
			 * {DocumentInfo.DocumentInfoModel}
			 */
			this._model = documentInfoModel;

			/**
			 * The default state will update the mouse position in the model. When leaving the viewport, reset position.
			 */
			this.registerState("default", {
				"mousemove": _.bind(function (e) {
					this._model.setMousePosition(this.getWorldPoint(e));
				}, this),
				"mouseleave": _.bind(function (e) {
					this._model.setMousePosition(null);
				}, this)
			});

			this._override("initialize", function (widget, toolManager) {
				this._super(widget, toolManager);
				this.registerPassiveEvents(["mousemove", "mouseleave"]);
				this.changeState("default");
			});
		};

		// extend from the AbstractTool
		MouseLocatorTool.prototype = Object.create(AbstractTool.prototype);
		MouseLocatorTool.prototype.constructor = MouseLocatorTool;

		/**
		 * @override
		 */
		MouseLocatorTool.prototype.getIconOffset = function () {
			var offset = null;
			var activeTool = this._toolManager.getActiveTool();
			if (activeTool) {
				offset = activeTool.getIconOffset();
			}
			return offset;
		};

		return MouseLocatorTool;

	});

define('web-viewer/documentInfo/DocumentInfoModule',["web-viewer/core/AbstractModule",
		"web-viewer/layout/component/DocumentSelection",
		"web-viewer/documentInfo/DocumentInfoWidget",
		"web-viewer/documentInfo/InfoWidget",
		"web-viewer/documentInfo/DebugWidget",
		"web-viewer/documentInfo/DocumentInfoModel",
		"web-viewer/documentInfo/MouseLocatorTool",
		"Mousetrap",
		"web-viewer/layout/LayoutConstants",
		"underscore",
		"component/toolbar/ToolbarComponent",
		"web-viewer/core/CoreConstants"
	],
	function (AbstractModule,
		DocumentSelection,
		DocumentInfoWidget,
		InfoWidget,
		DebugWidget,
		DocumentInfoModel,
		MouseLocatorTool,
		Mousetrap,
		LayoutConstants,
		_,
		ToolbarComponent,
		CoreConstants) {
		"use strict";

		/**
		 * This module is responsible for adding the document info widget (topbar)
		 *
		 * @exports DocumentInfoModule
		 * @constructor
		 * @augments Core.AbstractModule
		 * @param {Core.ViewerFacade} f
		 * @param {Boolean} silenced
		 */
		var DocumentInfoModule = function (f, silenced) {
			AbstractModule.call(this, f, silenced, "documentInfo");

			/**
			 * @member {Layout.Component.DocumentSelection} - mobile document selector, active document only
			 */
			this._documentSelection = null;

			// create the widget
			this._publishWidget(DocumentInfoWidget.widgetName, _.bind(function (layoutType) {
				this._documentInfoWidget = new DocumentInfoWidget(f);
				return this._documentInfoWidget;
			}, this));



			// create model, create tool
			this.documentInfoModel = new DocumentInfoModel(this.f, "documentInfo");
			var mouseLocatorTool = new MouseLocatorTool(f, this.documentInfoModel);
			this._publishTool(mouseLocatorTool);

			// create the Info widget
			this._publishWidget(InfoWidget.widgetName, _.bind(function (layoutType) {
				this._infoWidget = new InfoWidget(f, this.documentInfoModel);
				return this._infoWidget;
			}, this));

			// only publish the debugging-infowidget once!
			this._showDebugWidget = _.once(_.bind(function () {
				this._publishWidget(DebugWidget.widgetName, function (layoutType) {
					return new DebugWidget(f);
				});
			}, this));

			/**
			 * Toolbar Component: Document Selector
			 */
			this.f.i18n.loadBundle("viewer", function () {
				// the DocumentSelection only works correctly once the general language bundle is available
				this._publishToolbarComponent(LayoutConstants.ToolbarComponent.DOCUMENTSELECTOR, _.bind(function (layoutType) {
					this._documentSelection = new DocumentSelection(this.f, undefined, undefined, true, true);
					var documentSelectorComponent = new ToolbarComponent(LayoutConstants.ToolbarComponent.DOCUMENTSELECTOR, f);
					documentSelectorComponent.addObject(this._documentSelection.getActiveDocumentSelector());
					return documentSelectorComponent;
				}, this));
			}, this);


			//>>excludeStart("PExclude", pragmas.productionExclude);
			// on developer systems we can just enter "d e b u g (enter)" to open the widget
			// note, this code is not included in the compiled version!
			Mousetrap.bind('d e b u g enter', this._showDebugWidget);
			Mousetrap.bind("i c o n s enter", _.bind(this._showDebugIconList, this));
			//>>excludeEnd("PExclude");	

			// if the debug parameter is provided, show the info widget
			if (this.f.getProperty("debug")) {
				this._showDebugWidget();
			}

			// Listen to changes in selection (used in e.g. measure tools) and update model accordingly
			this.f.on("selection.changed", _.bind(this.documentInfoModel.setSelection, this.documentInfoModel));

			// Keyboard shortcuts to toggle units
			Mousetrap.bind("ctrl+u", _.bind(this._setNextSizeUnit, this), "keydown");
			Mousetrap.bind("ctrl+shift+u", _.bind(this._setNextResolutionUnit, this), "keydown");
		};


		// inherit
		DocumentInfoModule.prototype = Object.create(AbstractModule.prototype);
		// correct the constructor pointer 
		DocumentInfoModule.prototype.constructor = DocumentInfoModule;

		//>>excludeStart("PExclude", pragmas.productionExclude);
		// on developer systems we can just enter "iconlist (enter)" to open a popup with all icons
		// note, this code is not included in the compiled version!
		DocumentInfoModule.prototype._showDebugIconList = function () {
			this.f.ajax("/wcr-static/style/css/icons.css", {
				dataType: "text",
				success: function (data, textStatus, jqXHR) {
					var icons = _.sortBy(_.uniq(data.match(/\icon-WCR_[a-zA-Z0-9-]*/g), false));
					var iconList = $("<div>");
					_.each(icons, function (icon) {
						iconList.append("<div style='width: 100px; margin: 5px; border: 1px solid #cacaca; text-align: center; padding: 5px;'><p style='font-size:10px'>" + icon + "</p><i class='icon " + icon + "'/></div>");
					});

					iconList.css({
						position: "absolute",
						top: "0",
						left: "0",
						width: "100%",
						background: "white",
						"font-size": "32px",
						display: "flex",
						"flex-wrap": "wrap",
						"z-index": 100,
						"max-height": "100%",
						"overflow-y": "auto"
					});

					$(document.body).append(iconList);

					iconList.dblclick(function (element) {
						iconList.remove();
					});
				}
			});
		};
		//>>excludeEnd("PExclude");	

		/**
		 * Set the next size unit (circular)
		 * @param {Event} e - Event object
		 */
		DocumentInfoModule.prototype._setNextSizeUnit = function (e) {
			var currentSizeUnit = this.f.getUnits();
			var nextSizeUnit = (currentSizeUnit + 1) % _.size(CoreConstants.SizeUnits);
			this.f.setOption("PREFERENCES_UNIT_SIZE", nextSizeUnit, true);

			e.preventDefault();
			e.stopPropagation();
		};

		/**
		 * Set the next resolution unit (circular)
		 * @param {Event} e - Event object
		 */
		DocumentInfoModule.prototype._setNextResolutionUnit = function (e) {
			var currentResUnit = this.f.getResolutionUnits();
			var nextResUnit = (currentResUnit + 1) % _.size(CoreConstants.ResolutionUnits);
			this.f.setOption("PREFERENCES_UNIT_RESOLUTION", nextResUnit, true);
			this.f.setOption("PREFERENCES_UNIT_SCREENRULING", nextResUnit, true);
			

			e.preventDefault();
			e.stopPropagation();
		};

		return DocumentInfoModule;
	});

